VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Directory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function MakePath Lib "imagehlp.dll" Alias "MakeSureDirectoryPathExists" (ByVal lpPath As String) As Long
Private Declare Function GetFileSecurity Lib "advapi32.dll" Alias "GetFileSecurityA" (ByVal lpFileName As String, ByVal RequestedInformation As Long, pSecurityDescriptor As Any, ByVal nLength As Long, lpnLengthNeeded As Long) As Long
Private Declare Function GetSecurityDescriptorOwner Lib "advapi32.dll" (pSecurityDescriptor As Any, pOwner As Long, lpbOwnerDefaulted As Long) As Long
Private Declare Function IsValidSid Lib "advapi32.dll" (ByVal pSid As Long) As Long
Private Declare Function LookupAccountSid Lib "advapi32.dll" Alias "LookupAccountSidA" (ByVal lpSystemName As String, ByVal lpSid As Long, ByVal Name As String, cbName As Long, ByVal ReferencedDomainName As String, cbReferencedDomainName As Long, peUse As Long) As Long

Public Type DIRECTORYACCESSINFO
    CanReadDirectory As Boolean
    CanOpenFiles     As Boolean
    CanWriteFiles    As Boolean
    CanDeleteFiles   As Boolean
    CanCreateDirs    As Boolean
    CanDeleteDirs    As Boolean
End Type

Public Type DIRECTORYINFO
    DirectoryPath  As String
    DirectorySize  As Variant
    FileCount      As Long
    DirectoryCount As Long
    Owner          As String
End Type

Public Type BROWSENFO
    hwnd                    As Long
    Title                   As String
    SYSROOT                 As SHELLSPECIALFOLDER
    SELECTEDSYSFOLDER       As SHELLSPECIALFOLDER
    ROOTPATH                As String
    SELECTEDFOLDERPATH      As String
    Flags                   As ShellBrowseFlags
    RETURNEDFOLDERPATH      As String
    INVALIDSELECTIONMESSAGE As String
    INVALIDSELECTIONTITLE   As String
End Type

Public Enum SHELLSPECIALFOLDER
    sfALTSTARTUP = &H1D
    sfAPPDATA = &H1A
    sfBITBUCKET = &HA
    sfCOMMONALTSTARTUP = &H1E
    sfCOMMONAPPDATA = &H23
    sfCOMMONDESKTOPDIR = &H19
    sfCOMMONFAVORITES = &H1F
    sfCOMMONPROGRAMS = &H17
    sfCOMMONSTARTMENU = &H16
    sfCOMMONSTARTUP = &H18
    sfCONTROLS = &H3
    sfCOOKIES = &H21
    sfDESKTOP = &H0
    sfDESKTOPDIRECTORY = &H10
    sfDRIVES = &H11
    sfFAVORITES = &H6
    sfFONTS = &H14
    sfHISTORY = &H22
    sfINTERNETCACHE = &H20
    sfLOCALAPPDATA = &H1C
    sfMYPICTURES = &H27
    sfNETHOOD = &H13
    sfNETWORK = &H12
    sfPERSONAL = &H5
    sfPRINTERS = &H4
    sfPRINTHOOD = &H1B
    sfPROFILE = &H28
    sfPROGRAMFILES = &H26
    sfPROGRAMS = &H2
    sfRECENT = &H8
    sfSENDTO = &H9
    sfSTARTMENU = &HB
    sfSTARTUP = &H7
    sfSYSTEM = &H25
    sfTEMPLATES = &H15
    sfWINDOWS = &H24
End Enum

Public Enum ShellBrowseFlags
    BIF_RETURNONLYFSDIRS = &H1
    BIF_DONTGOBELOWDOMAIN = &H2
    BIF_STATUSTEXT = &H4
    BIF_RETURNFSANCESTORS = &H8
    BIF_EDITBOX = &H10
    BIF_VALIDATE = &H20
    BIF_USENEWUI = &H40
    BIF_NEWDIALOGSTYLE = &H40
    BIF_BROWSEINCLUDEURLS = &H80
    BIF_UAHINT = &H100
    BIF_NONEWFOLDERBUTTON = &H200
    BIF_NOTRANSLATETARGETS = &H400
    BIF_BROWSEFORCOMPUTER = &H1000
    BIF_BROWSEFORPRINTER = &H2000
    BIF_BROWSEINCLUDEFILES = &H4000
    BIF_SHAREABLE = &H8000
End Enum

Public Type DIROPEATION
    hwnd                As Long
    OPERATION           As OPERATION
    Source              As String
    Target              As String
    INCLUDESUBDIRCTORYS As Boolean
    Confirm             As Boolean
    ShowProgress        As Boolean
    MOVETORECYCLEBIN    As Boolean
    SHOWDIALOGS         As Boolean
End Type

Public Enum OPERATION
    doCOPY = 1
    doMOVE = 2
    doRENAME = 3
    doDELETE = 4
End Enum

Public Function DirectoryDeleteFiles(ByVal Directory As String, _
                                     ByVal FileList As Variant, _
                                     Optional DeleteAllFiles As Boolean = False) As Long
    Dim F() As Variant, Dl() As Variant
    Dim D As String
    
    On Local Error GoTo Quit
    
    Directory = GetDir(Directory)
    
    If DeleteAllFiles Then Call Read(Directory, Dl, F, vbSystem + vbReadOnly + vbHidden)
            
    FileList = F
            
    If Not DLL.ARRAY.isArray(FileList) Then
        ReDim F(0)
        F(0) = FileList
    Else
        F = FileList
    End If

    D = Dir(Directory & "*.*", vbDirectory + vbArchive + vbHidden + vbReadOnly + vbSystem)
    
    Do While Len(D)
        If D <> "." And D <> ".." Then
            If (GetAttr(Directory & D) And vbDirectory) <> vbDirectory Then
                If DLL.ARRAY.Exist(F, D) Or DeleteAllFiles Then
                    Call DLL.File.fKill(Directory & D)
                End If
            End If
        End If
        
        D = Dir
    Loop
    
    Exit Function
    
Quit:
    DirectoryDeleteFiles = Err.Number
    
    Call ERROR(Directory_, "DirectoryDeleteFiles", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Exist(ByVal Path As String, Optional sCreatePath As Boolean = False) _
                            As Boolean
    Dim FS As Object
   
    On Local Error GoTo Quit
    
    Path = GetDir(Path)
    
    Set FS = CreateObject("Scripting.FileSystemObject")
    
    If FS.FolderExists(Path) Then
        Exist = True
    Else
        If sCreatePath Then Exist = CreatePath(Path)
    End If
    
Quit:
    Set FS = Nothing
    
    Err.Clear
    
End Function
Public Function BrowseForDirectory(BROWSEINFO As BROWSENFO) As String
    
    BrowseForDirectory = ShellBrowseForFolder(BROWSEINFO)

End Function
Public Function CreatePath(ByVal Path As String) As Boolean
    
    If MakePath(GetDir(Path)) <> 0 Then CreatePath = True

End Function
Public Function Find(ByVal DirectoryToFind As String, _
                     ByVal StartSearchPath As String, _
                     Optional SearchAllDrives As Boolean = False, _
                     Optional ShowProgress As Boolean = False) As String
    Dim P As Long
    Dim sDrv As String, cDrv As String
    
    On Local Error GoTo Quit
    
    If StartSearchPath = "" And Not SearchAllDrives Then Exit Function
    
    If ShowProgress Then basPModule.LoadProgbar = True
    
    If SearchAllDrives Then
        sDrv = DLL.Drive.Get_AllDrives
        
        sDrv = Replace(sDrv, "A", "")
        sDrv = Replace(sDrv, "B", "")
        
        For P = 1 To Len(sDrv)
            cDrv = mID$(sDrv, P, 1) & ":\"
            Find = GetAllFiles(cDrv, DirectoryToFind, True, ShowProgress)
            
            If Len(Find) Then Exit For
        Next P
    Else
        Find = GetAllFiles(StartSearchPath, DirectoryToFind, True, ShowProgress)
    End If
    
Quit:
    If Err.Number <> 0 Then Call ERROR(Directory_, "Find", Err.Number, Err.Description)
    
    If ShowProgress Then
        Unload basPModule.PBar
        
        Set basPModule.PBar = Nothing
    End If
    
    Err.Clear
    
End Function
Public Function isDirectoryEmpty(ByVal Directory As String) As Boolean
    
    isDirectoryEmpty = (PathIsDirectoryEmpty(Directory) = 1)

End Function
Public Function Read(ByVal Directory As String, _
                     DirList As Variant, FileList As Variant, _
                     Optional Attributes As VbFileAttribute = vbHidden + vbSystem + _
                                                              vbReadOnly) As Long
    Dim File As String
    Dim x As Long, Y As Long
    Dim At As VbFileAttribute, Fa As VbFileAttribute
    
    On Local Error GoTo Quit
    
    Erase DirList: Erase FileList
    
    x = 0: Y = 0
    
    At = vbDirectory
    
    If Attributes And vbSystem Then At = At + vbSystem
    If Attributes And vbReadOnly Then At = At + vbReadOnly
    If Attributes And vbHidden Then At = At + vbHidden
    If Attributes And vbAlias Then At = At + vbAlias
    If Attributes And vbArchive Then At = At + vbArchive
    If Attributes And vbNormal Then At = At + vbNormal
    If Attributes And vbVolume Then At = At + vbVolume

    Directory = GetDir(Directory)
    
    File = Directory
    File = Dir(File & "*.*", At)
    
    On Local Error Resume Next

    Do While Len(File)
        If File <> "." And File <> ".." Then
            Fa = (GetAttr(Directory & File) And vbDirectory)
                    
            If Err.Number = 0 Then
                If Fa = vbDirectory Then
                    ReDim Preserve DirList(x)
                    
                    DirList(x) = File
                    x = x + 1
                Else
                    ReDim Preserve FileList(Y)
                    
                    FileList(Y) = File
                    Y = Y + 1
                End If
            Else
                If Err.Number <> 5 Then GoTo Quit
            
                Err.Clear
            End If
        End If
        
        File = Dir
    Loop
    
    Exit Function
    
Quit:
    Read = Err.Number
    
    Call ERROR(Directory_, "Read", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function isDirectoryContainingDirs(ByVal Directory As String) As Boolean
    Dim D() As Variant, F() As Variant
    
    If Read(Directory, D, F) = 0 Then
        If DLL.ARRAY.isDIM(D) Then
            isDirectoryContainingDirs = True
        End If
    End If
    
End Function
Public Function isDirectoryContainingFiles(ByVal Directory As String) As Boolean
    Dim D() As Variant, F() As Variant
    
    If Read(Directory, D, F) = 0 Then
        If DLL.ARRAY.isDIM(F) Then
            isDirectoryContainingFiles = True
        End If
    End If
    
End Function
Public Function DirectroryOperation(OPERATION As DIROPEATION) As Long

    With OPERATION
        DirectroryOperation = SH_FileOperation(.hwnd, .OPERATION, .Source, .Target, _
                                               .INCLUDESUBDIRCTORYS, .Confirm, .SHOWDIALOGS, _
                                               .ShowProgress, .MOVETORECYCLEBIN)
    End With
    
End Function
Public Function PathIsDirectory(Path As String) As Boolean
    
    PathIsDirectory = Exist(Path)

End Function
Public Function Delete(ByVal Directory As String, _
                       Optional ByVal DeleteContent As Boolean = False) As Long
    Dim fso As New FileSystemObject
    
    On Local Error Resume Next
    
    Directory = CutDir(Directory)
    
    If DeleteContent Then
        Delete = DeleteTree(Directory)
        
        Exit Function
    End If
    
    Call SetAttr(Directory, vbNormal)
    
    Err.Clear
           
    Call fso.DeleteFolder(Directory, True)
    
Quit:
    Delete = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Directory_, "Delete", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function DirectoryIsAccesable(ByVal Directory As String, _
                                     Optional ErrorNumber As Long) As DIRECTORYACCESSINFO
    Dim Fl() As String, Dl() As String, File As String, Dir As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Directory = GetDir(Directory)
    File = DLL.File.TempFile_Create(Directory)
    
    Dir = DLL.STRING.Get_RandomString(20, True, True, True, True, False)
    Dir = Directory & Dir
    
    With DirectoryIsAccesable
        If DLL.Directory.PathIsDirectory(Directory) Then
            .CanReadDirectory = (DLL.Directory.Read(Directory, Dl, Fl, vbHidden + vbReadOnly + vbSystem) = 0)
        
            .CanWriteFiles = (DLL.TEXT.TextFile_WriteText(File, "test") = 0)
            .CanOpenFiles = ((DLL.TEXT.TextFile_Read(File) = "test"))
            .CanDeleteFiles = (DLL.File.fKill(File) = 0)
        
            .CanCreateDirs = CreatePath(Dir)
            .CanDeleteDirs = (Delete(Dir) = 0)
        End If
    End With
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Directory_, "DirectoryIsAccesable", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Sub DelTree(ByVal Directory As String)
    Dim sCurrFile As String, Path As String
    
    On Local Error Resume Next
    
    Directory = GetDir(Directory)
    
    sCurrFile = Dir(Directory & "*.*", vbDirectory + vbArchive + vbHidden + _
                                       vbReadOnly + vbSystem)
     
    Do While Len(sCurrFile) > 0
        Path = Directory & sCurrFile
        
        If sCurrFile <> "." And sCurrFile <> ".." Then
            If (GetAttr(Path) And vbDirectory) = vbDirectory Then
                Call DelTree(Path)
                
                sCurrFile = Dir(Directory & "*.*", vbDirectory)
            Else
                Call SetAttr(Path, vbNormal)
                
                Kill Path
                                                
                sCurrFile = Dir
            End If
        Else
            sCurrFile = Dir
        End If
    Loop
    
    RmDir Directory
    
    Err.Clear
    
End Sub
Public Function DirectoryDeleteSubDirs(ByVal Directory As String, ByVal DirList As Variant, _
                                       Optional DeleteAllSubDirs As Boolean = False) _
                                                As Long
    Dim D() As Variant, Fl() As Variant
    Dim DF As String

    On Local Error GoTo Quit
    
    Directory = GetDir(Directory)
    
    If DeleteAllSubDirs Then
        Call Read(Directory, D, Fl, vbHidden + vbReadOnly + vbSystem)
    Else
        DirList = D
    End If
        
    If Not DLL.ARRAY.isArray(DirList) Then
        ReDim D(0)
        D(0) = DirList
    Else
        D = DirList
    End If

StartLoop:
    DF = Dir(Directory & "*.*", vbDirectory + vbArchive + vbHidden + _
                                vbReadOnly + vbSystem)
    
    Do While Len(DF)
        If DF <> "." And DF <> ".." Then
            If (GetAttr(Directory & DF) And vbDirectory) = vbDirectory Then
                If DLL.ARRAY.Exist(D, DF) Or DeleteAllSubDirs Then
                    DirectoryDeleteSubDirs = DeleteTree(Directory & DF)
                    
                    GoTo StartLoop
                End If
            End If
        End If
        
        DF = Dir
    Loop
    
    Exit Function
    
Quit:
    DirectoryDeleteSubDirs = Err.Number
    
    Call ERROR(Directory_, "DirectoryDeleteSubDirs", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Get_DirectoryInfo(ByVal Directory As String, _
                                  ByVal InclSubDirectorys As Boolean, _
                                  ByVal ShowProgress As Boolean) As DIRECTORYINFO
    Dim BY As BYTEINFOS
    Dim DirInfo As DIRECTORYINFO
    
    If Not Exist(Directory) Then Exit Function
    
    Directory = GetDir(Directory)
    
    With DirInfo
        .DirectorySize = GetAllPath(Directory, InclSubDirectorys, .FileCount, _
                                    .DirectoryCount, ShowProgress)
        .DirectoryPath = Directory
    
        BY = DLL.MATH.BYTEINFO(.DirectorySize, biBytes)
        .DirectorySize = BY.KiloBytes
        
        .Owner = Get_Owner(Directory)
    End With

    Get_DirectoryInfo = DirInfo
    
End Function
Public Function Get_DirectorySize(ByVal Directory As String, _
                                  ByVal InclSubDirectorys As Boolean, _
                                  Optional ShowProgress As Boolean = False) As Variant
    Dim DI As DIRECTORYINFO
    
    DI = Get_DirectoryInfo(Directory, InclSubDirectorys, ShowProgress)

    Get_DirectorySize = DI.DirectorySize
    
End Function
Public Function Get_Owner(ByVal Directory As String) As String
    Dim lngSize As Long, lpSid As Long, lngDummy As Long
    Dim bytSecurityDescr() As Byte
    
    Const OWNER_SECURITY_INFORMATION As Long = 1

    Call GetFileSecurity(Directory, OWNER_SECURITY_INFORMATION, ByVal 0, 0, lngSize)
    
    If lngSize <> 0 Then
        ReDim bytSecurityDescr(lngSize - 1)
        
        If GetFileSecurity(Directory, OWNER_SECURITY_INFORMATION, bytSecurityDescr(0), lngSize, lngSize) <> 0 Then
            Call GetSecurityDescriptorOwner(bytSecurityDescr(0), lpSid, lngDummy)
            
            If lpSid <> 0 Then Get_Owner = Sid2String(lpSid)
        End If
    End If

End Function
Private Function Sid2String(ByVal lpSid As Long, Optional ComputerName As String = vbNullString) As String
    Dim cbAccountName As Long, cbDomainName As Long, peUse As Long, lngRet As Long
    Dim strAccountName As String, strDomainName As String
    
    If IsValidSid(lpSid) <> 0 Then
        lngRet = LookupAccountSid(ComputerName, lpSid, 0, cbAccountName, 0, cbDomainName, peUse)
        
        strAccountName = Space(cbAccountName + 1)
        strDomainName = Space(cbDomainName + 1)
        
        lngRet = LookupAccountSid(ComputerName, lpSid, strAccountName, cbAccountName, strDomainName, cbDomainName, peUse)
        
        If lngRet <> 0 Then
            Sid2String = Left(strDomainName, cbDomainName) & "\" & Left(strAccountName, cbAccountName)
        Else
            Sid2String = "<UNKNOWN SID>"
        End If
    Else
        Sid2String = "<INVALID SID>"
    End If
    
End Function
Public Function OpenPath(ByVal Path As String, Optional SelectedItem As String, _
                                               Optional isRoot As Boolean = False) As Boolean
    Dim Param As String
    
    If Not Exist(Path) Then Exit Function

    Path = GetDir(Path)
    Param = Path

    If SelectedItem <> "" Then Param = "/select," & (Path & SelectedItem)
    If isRoot Then Param = "/root," & Param
    
    OpenPath = DLL.SHELL.Execute("Explorer.exe", Param, vbMaximizedFocus)

End Function
Public Function ReadAllSubDirs(ByVal Directory As String, _
                               Optional ShowProgress As Boolean = False) As String()
    Dim frm As Form
    
    If ShowProgress = True Then
        Set frm = New ProgBar
        Load frm
        
        frm.Picture1.Visible = False
        frm.Frame1.Caption = "Verzeichnisse werden durchsucht..."
        frm.Message.Caption = "Bitte warten..."
        frm.Message.Top = 480
        
        Call DLL.FORMS.StayOnTop(frm)
        Call DLL.FORMS.Center(frm, ccMIDDLE)

        frm.Visible = True
        
        DoEvents
    End If
    
    Erase Dirs
    
    Call GetAllSubDirs(Directory, ShowProgress, frm)

    ReadAllSubDirs = Dirs
    
    Erase Dirs
    
    If ShowProgress = True Then Unload frm
        
    Set frm = Nothing
    
    Err.Clear
    
End Function
