VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Drive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Type OVERLAPPED
    Internal     As Long
    InternalHigh As Long
    offset       As Long
    OffsetHigh   As Long
    hEvent       As Long
End Type

Private Declare Function SetVolumeLabel Lib "kernel32" Alias "SetVolumeLabelA" (ByVal lpRootPathName As String, ByVal lpVolumeName As String) As Long
Private Declare Function SHFormatDrive Lib "shell32" (ByVal hWndOwner As Long, ByVal lngDrive As Long, ByVal lngCapacity As Long, ByVal lngFormatType As Long) As Long
Private Declare Function GetDriveTypeB Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function mciExecute Lib "winmm.dll" (ByVal lpStrCommand As String) As Long
Private Declare Function GetDiskFreeSpace Lib "kernel32" Alias "GetDiskFreeSpaceA" (ByVal lpRootPathName As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTotalNumberOfClusters As Long) As Long
Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Declare Function WNetGetConnection Lib "mpr.dll" Alias "WNetGetConnectionA" (ByVal lpszLocalName As String, ByVal lpszRemoteName As String, cbRemoteName As Long) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, hTemplateFile As Long) As Long
Private Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, ByRef lpInBuffer As Any, ByVal nInBufferSize As Long, ByRef lpOutBuffer As Any, ByVal nOutBufferSize As Long, ByRef lpBytesReturned As Long, ByRef lpOverlapped As OVERLAPPED) As Long

Public Type DRIVEFLAGINFO
    Flags       As Long
    Preserved   As Boolean
    Sensistive  As Boolean
    Unicode     As Boolean
    Persistent  As Boolean
    File_Compr  As Boolean
    Vol_Compr   As Boolean
End Type

Public Type DRIVEINFO
    Drive             As String
    Label             As String
    FileSystem        As String
    FileLen           As Variant
    
    Cluster           As Variant
    SectorsPerCluster As Variant
    BytesPerCluster   As Variant
    FreeCluster       As Variant
    
    Type              As String
    Serial            As String
        
    DiskSpaceTotal    As Variant
    DiskSpaceFree     As Variant
    DiskSpaceUsed     As Variant
    
    Flags             As DRIVEFLAGINFO
End Type

Private Type SCSI_PASS_THROUGH_DIRECT
    Length             As Integer
    ScsiStatus         As Byte
    PathId             As Byte
    TargetId           As Byte
    Lun                As Byte
    CdbLength          As Byte
    SenseInfoLength    As Byte
    DataIn             As Byte
    DataTransferLength As Long
    TimeOutValue       As Long
    DataBuffer         As Long
    SenseInfoOffset    As Long
    Cdb(15)            As Byte
    Fill(2)            As Byte
End Type

Private Type SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER
    spt             As SCSI_PASS_THROUGH_DIRECT
    Fill            As Long
    SenseBuffer(31) As Byte
End Type

Private Type MMC
    PageCode          As Byte
    PageLen           As Byte
    rsvd2(7)          As Byte
    ReadSupported     As Byte
    WriteSupported    As Byte
    MISC(3)           As Byte
    MaxReadSpeed(1)   As Byte
    NumVolLevels(1)   As Byte
    BufferSize(1)     As Byte
    CurrReadSpeed(1)  As Byte
    rsvd              As Byte
    misc2             As Byte
    MaxWriteSpeed(1)  As Byte
    CurrWriteSpeed(1) As Byte
    Rest(20)          As Byte
End Type

Public Enum FormatOption
    foCAPACITY_DEFAULT = 0
    foCAPACITY_360 = 3
    foCAPACITY_720 = 5
End Enum

Public Enum DriveTyp
    dtREMOVABLE = 0
    dtHARDDISK = 1
    dtNETDRIVE = 2
    dtCDROM = 3
    dtRAMDISK = 4
    dtUNKNOWN = -1
    dtINVALIDDRIVE = -3
End Enum

Public Enum CDROMCOMMAND
    cdOPEN = 1
    cdCLOSE = 2
End Enum

Public Enum VIRTUALDRIVECOMMAND
    vdREMOVE = 0
    vdCREATE = 1
End Enum

Public Enum CDROMTYP
    cdCDROM = 0
    cdCDWRITER = 1
    cdCDRWWRITER = 2
    cdDVDROM = 3
    cdDVDWRITER = 4
    cdUNKNOWN = -1
    cdINVALIDDRIVE = -3
End Enum

Public Function CDROM(Command As CDROMCOMMAND) As Boolean
    Dim cmd As String
    Dim Result As Long
    
    Select Case Command
        Case cdCLOSE: cmd = "closed"
        Case cdOPEN:  cmd = "open"
        Case Else:    Exit Function
    End Select
    
    Result = mciExecute("Set CDaudio door " & cmd)
    
    If Result <> 0 Then CDROM = True
    
End Function
Public Function VirtualDrive(Command As VIRTUALDRIVECOMMAND, _
                             TargetDrive As String, _
                             Optional SourceDir As String, _
                             Optional ErrorNumber As Long) As Boolean
    Dim strShell As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    TargetDrive = getDrive(TargetDrive, False)
    If TargetDrive = "" Then Exit Function
    
    TargetDrive = Left$(TargetDrive, 1)
    
    Select Case Command
        Case vdCREATE
            If SourceDir = "" Then Exit Function
            
            If TargetDrive = "" Then
                TargetDrive = Get_NextFreeDrive
                TargetDrive = Left$(TargetDrive, 1)
            End If
            
            If Not Exist(TargetDrive) Then
                SourceDir = DLL.File.Get_ShortPath(SourceDir)
        
                strShell = "subst " & TargetDrive & ": " & SourceDir
                   
                Call DLL.SHELL.ExecuteAndWait(strShell, vbHide)
                           
                If Exist(TargetDrive & ":\") Then VirtualDrive = True
            End If
        Case vdREMOVE
            If Exist(TargetDrive) Then
                strShell = "subst /D " & TargetDrive & ":"
                                 
                Call DLL.SHELL.ExecuteAndWait(strShell, vbHide)
                
                If Not Exist(TargetDrive & ":\") Then VirtualDrive = True
            End If
    End Select

    Exit Function

Quit:
    ErrorNumber = Err.Number

    Call ERROR(Drive_, "VirtualDrive", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_NextFreeDrive() As String
    Dim P As Long
    Dim Drive As String, Drives As String
    
    Drives = Get_AllDrives
    
    For P = Asc("C") To Asc("Z")
        Drive = Chr$(P)
        
        If InStr(Drives, Drive) = 0 Then
            Get_NextFreeDrive = Drive & ":\"
            
            Exit Function
        End If
    Next P
    
End Function
Public Function Get_AllDrives() As String
    Dim Result As Long
    Dim Puffer As String, Drives As String
    
    Const L = 64
    
    Puffer = Space(L)
    
    Result = GetLogicalDriveStrings(L, Puffer)
    Drives = Left$(Puffer, Result)
    
    Drives = Replace(Drives, ":", "")
    Drives = Replace(Drives, "\", "")
    Drives = Replace(Drives, Chr$(0), "")
    
    Drives = Trim$(Drives)
    Drives = UCase$(Drives)
    
    Get_AllDrives = Drives
    
End Function
Public Function Get_DriveType(ByVal Drive As String) As DriveTyp
    Dim Typ As Long
    
    Get_DriveType = dtINVALIDDRIVE

    Drive = getDrive(Drive)
    If Drive = "" Then Exit Function
    
    Typ = GetDriveTypeB(Drive)

    Select Case Typ
        Case 2: Get_DriveType = dtREMOVABLE
        Case 3: Get_DriveType = dtHARDDISK
        Case 4: Get_DriveType = dtNETDRIVE
        Case 5: Get_DriveType = dtCDROM
        Case 6: Get_DriveType = dtRAMDISK
        
        Case Else
                Get_DriveType = dtUNKNOWN
    End Select
    
End Function
Public Function isDriveReady(ByVal Drive As String) As Boolean
    Dim OldDrive As String
    
    On Local Error GoTo Quit
  
    OldDrive = CurDir()
    
    Drive = getDrive(Drive)
    
    ChDir Drive
    
Quit:
    isDriveReady = (Err.Number = 0)

    ChDir OldDrive
    
    Err.Clear
    
End Function
Public Function Get_FirstCDdrive() As String
    Dim CDDrive As String
    
    Get_FirstCDdrive = Get_DriveByType(dtCDROM)
    
    If Len(Get_FirstCDdrive) > 1 Then
        CDDrive = Left$(Get_FirstCDdrive, 1)
        Get_FirstCDdrive = CDDrive
    End If

End Function
Public Function Get_DriveByType(DriveType As DriveTyp) As String
    Dim Drives  As String, Drive As String
    Dim P As Long
    
    Drives = Get_AllDrives
        
    For P = 1 To Len(Drives)
        Drive = mID$(Drives, P, 1)
        
        If Get_DriveType(Drive) = DriveType Then
            Get_DriveByType = Get_DriveByType & Drive
        End If
    Next P
    
End Function
Public Function DriveBox_Clear(DriveBox As Object, _
                               Optional ErrorNumber As Long) As Boolean

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    DriveBox_Clear = DLL.LB.Clear(DriveBox.hwnd)

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Drive_, "DriveBox_Clear", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function DriveBox_RemoveDrive(DriveBox As Object, ByVal Drive As String, _
                                     Optional ErrorNumber As Long) As Boolean
    Dim boxDrive As String
    Dim P As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    DriveBox_RemoveDrive = False
    
    Drive = getDrive(Drive, False)
    If Drive = "" Then Exit Function
    
    Drive = LCase$(mID$(Drive, 1, 1))

    For P = 0 To (DriveBox.ListCount - 1)
        boxDrive = LCase$(mID(DriveBox.List(P), 1, 1))
        
        If boxDrive = Drive Then
            DriveBox_RemoveDrive = DLL.LB.RemoveIndex(DriveBox.hwnd, P)
            
            Exit Function
        End If
    Next P

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Drive_, "DriveBox_RemoveDrive", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function DriveBox_DriveExist(DriveBox As Object, ByVal Drive As String, _
                                    ErrorNumber As Long) As Boolean
    Dim P As Long
    Dim boxDrive As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    DriveBox_DriveExist = False
    
    Drive = getDrive(Drive, False)
    If Drive = "" Then Exit Function
    
    Drive = LCase$(mID$(Drive, 1, 1))
    
    For P = 0 To (DriveBox.ListCount - 1)
        boxDrive = LCase$(mID$(DriveBox.List(P), 1, 1))
        
        If Drive = boxDrive Then
            DriveBox_DriveExist = True
            
            Exit Function
        End If
    Next P
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Drive_, "DriveBox_DriveExist", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function DriveBox_SelectDriveTyp(DrvListBox As Object, DriveType As DriveTyp) As Long
    Dim Drive  As String
    Dim x As Long
    
    On Local Error GoTo Quit
    
    Do While x < DrvListBox.ListCount
        Drive = Left$(DrvListBox.List(x), 1)
        
        If Get_DriveType(Drive) <> DriveType Then
            Call SendMessage(DrvListBox.hwnd, CB_DELETESTRING, ByVal x, ByVal CLng(0))
        Else
            x = x + 1
        End If
    Loop
    
    If DrvListBox.ListCount Then Call SendMessage(DrvListBox.hwnd, CB_SETCURSEL, CLng(0), CLng(1))
    
    Exit Function
    
Quit:
    DriveBox_SelectDriveTyp = Err.Number
    
    Call ERROR(Drive_, "DriveBox_Select", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function DriveBox_RemoveDriveTyp(DriveBox As Object, _
                                        ByVal DriveTyp As DriveTyp, _
                                        Optional ErrorNumber As Long) As Boolean
    Dim P As Long
    Dim Drive As String
    Dim DT As DriveTyp
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    For P = (DriveBox.ListCount - 1) To 0 Step -1
        Drive = mID$(DriveBox.List(P), 1, 1)
        DT = DLL.Drive.Get_DriveType(Drive)
        
        If DT = DriveTyp Then Call DLL.LB.RemoveIndex(DriveBox.hwnd, P)
    Next P
    
    DriveBox_RemoveDriveTyp = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    DriveBox_RemoveDriveTyp = False
    
    Call ERROR(Drive_, "DriveBox_RemoveDriveTyp", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Exist(ByVal Drive As String) As Boolean
    
    Drive = getDrive(Drive)
    If Drive <> "" Then Exist = True

End Function
Private Function GetDriveHandle(ByVal Drv As String, ByRef fh As Long) As Boolean
    Dim SD As SECURITY_ATTRIBUTES
    Dim Flags As Long

    Const FILE_SHARE_WRITE = &H2

    Flags = GENERIC_READ
    Flags = Flags Or GENERIC_WRITE

    fh = CreateFile("\\.\" & Drv & ":", Flags, FILE_SHARE_READ Or FILE_SHARE_WRITE, _
                     SD, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, ByVal 0)

    If fh = INVALID_HANDLE_VALUE Then Exit Function

    GetDriveHandle = True
    
End Function
Private Function IsBitSet(ByVal InByte As Byte, ByVal Bit As Byte) As Boolean
    IsBitSet = ((InByte And (2 ^ Bit)) > 0)
End Function
Public Function Get_CDROMType(ByVal Drive As String) As CDROMTYP
    Dim Status As Long, hf As Long
    Dim pswb As SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER
    Dim OL As OVERLAPPED
    Dim Length As Long, returned As Long
    Dim MMCaps As MMC

    Const SCSI_IOCTL_DATA_IN = 1
    Const IOCTL_SCSI_PASS_THROUGH_DIRECT = &H4D014

    On Local Error GoTo Quit
    
    Get_CDROMType = cdINVALIDDRIVE

    Drive = getDrive(Drive)
    If Drive = "" Then Exit Function
    Drive = Left$(Drive, 1)

    If DLL.Drive.Get_DriveType(Drive) <> dtCDROM Then Exit Function

    If Not GetDriveHandle(Drive, hf) Then Exit Function

    With pswb
        .spt.SenseInfoOffset = Len(.spt) + Len(.Fill)
        .spt.DataTransferLength = Len(MMCaps)
        .spt.DataBuffer = VarPtr(MMCaps)
        .spt.DataIn = SCSI_IOCTL_DATA_IN
        .spt.SenseInfoLength = 14
        .spt.TimeOutValue = 9999
        .spt.CdbLength = 10
        .spt.Length = 44
    End With

    With pswb.spt
        .Cdb(0) = &H5A
        .Cdb(2) = &H2A And &H3F
        .Cdb(8) = Len(MMCaps)
    End With

    Length = Len(pswb)
    Status = DeviceIoControl(hf, IOCTL_SCSI_PASS_THROUGH_DIRECT, pswb, Length, pswb, Length, returned, OL)

    If Status = 1 Then
        If pswb.spt.ScsiStatus = 0 Then

            If IsBitSet(MMCaps.ReadSupported, 0) Then Get_CDROMType = cdCDROM
            If IsBitSet(MMCaps.ReadSupported, 3) Then Get_CDROMType = cdDVDROM
            If IsBitSet(MMCaps.WriteSupported, 0) Then Get_CDROMType = cdCDWRITER
            If IsBitSet(MMCaps.WriteSupported, 1) Then Get_CDROMType = cdCDRWWRITER
            If IsBitSet(MMCaps.WriteSupported, 4) Then Get_CDROMType = cdDVDWRITER
            
            If Get_CDROMType = cdINVALIDDRIVE Then Get_CDROMType = cdUNKNOWN
        End If
    End If

    CloseHandle hf
    
    Exit Function
    
Quit:
    Call ERROR(Drive_, "Get_CDROMType", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Sub Format(ByVal hwnd As Long, ByVal Drive As String, _
                  FormatCapacity As FormatOption, _
                  Optional QuickFormat As Boolean = False)
    Dim lngFormatType As Long, Q As Long
    
    Const SHFD_FORMAT_QUICK = 0
    Const SHFD_FORMAT_FULL = 1

    Drive = getDrive(Drive)
    If Drive = "" Then Exit Sub
    
    Drive = Left$(Drive, 1)
    Drive = Asc(Drive) - 65
         
    Q = SHFD_FORMAT_QUICK
    If DLL.SYSTEM.isWindowsNT Then Q = 1
        
    lngFormatType = IIf(QuickFormat, Q, SHFD_FORMAT_FULL)
        
    Call SHFormatDrive(hwnd, Drive, FormatCapacity, lngFormatType)
    
End Sub
Public Function Get_DriveInfo(ByVal Drive As String) As DRIVEINFO
    Dim Result As Long
    Dim SerN As Long, PathL As Long, Flags As Long
    Dim XPC As Long, BPS As Long
    Dim FreeB As Double, FreeC As Long
    Dim TotB As Double, TotC As Long
    Dim VolN As String * 256
    Dim FileS As String * 256
    
    Const FS_CASE_IS_PRESERVED = &H2
    Const FS_CASE_SENSITIVE = &H1
    Const FS_UNICODE_STORED_ON_DISK = &H4
    Const FS_PERSISTENT_ACLS = &H8
    Const FS_FILE_COMPRESSION = &H10
    Const FS_VOL_IS_COMPRESSED = &H8000&

    Drive = getDrive(Drive)

    With Get_DriveInfo
        .BytesPerCluster = 0
        .Cluster = 0
        .DiskSpaceFree = 0
        .DiskSpaceTotal = 0
        .DiskSpaceUsed = 0
        .Drive = Drive
        .FileLen = 0
        .FileSystem = ""
        .Flags.File_Compr = False
        .Flags.Flags = 0
        .Flags.Persistent = False
        .Flags.Preserved = False
        .Flags.Sensistive = False
        .Flags.Unicode = False
        .Flags.Vol_Compr = False
        .FreeCluster = 0
        .Label = ""
        .SectorsPerCluster = 0
        .Serial = ""
        .Type = dtINVALIDDRIVE
    End With
        
    If Drive = "" Then Exit Function

    Result = GetVolumeInformation(Drive, VolN, 256, SerN, PathL, Flags, FileS, 256)
    If Result = 0 Then Exit Function
    
    Result = GetDiskFreeSpace(Drive, XPC, BPS, FreeC, TotC)
    If Result = 0 Then Exit Function

     With Get_DriveInfo
        .Type = Get_DriveType(Drive)
        .Label = Left$(VolN, InStr(VolN, Chr$(0)) - 1)
        .Serial = SerN
        .FileSystem = Left$(FileS, InStr(FileS, Chr$(0)) - 1)
        .FileLen = PathL
        
        With .Flags
            .Flags = Flags
            
            If .Flags And FS_CASE_IS_PRESERVED Then .Preserved = True
            If .Flags And FS_CASE_SENSITIVE Then .Sensistive = True
            If .Flags And FS_UNICODE_STORED_ON_DISK Then .Unicode = True
            If .Flags And FS_PERSISTENT_ACLS Then .Persistent = True
            If .Flags And FS_FILE_COMPRESSION Then .File_Compr = True
            If .Flags And FS_VOL_IS_COMPRESSED Then .Vol_Compr = True
        End With
        
        .Cluster = TotC
        .SectorsPerCluster = XPC
        .BytesPerCluster = BPS
        .FreeCluster = FreeC
              
         TotB = CDbl(TotC) * XPC * BPS
        .DiskSpaceTotal = TotB
        
        FreeB = CDbl(FreeC) * XPC * BPS
        .DiskSpaceFree = FreeB
        
        .DiskSpaceUsed = .DiskSpaceTotal - .DiskSpaceFree
    End With

End Function
Public Function Set_DriveLabel(ByVal Drive As String, ByVal NewLabel As String) As Boolean
    
    Drive = getDrive(Drive)
    If Drive = "" Then Exit Function
    
    If SetVolumeLabel(Drive, NewLabel) <> 0 Then Set_DriveLabel = True
        
End Function
Public Function Get_FullNetPath(ByVal Drive As String) As String
    Dim Result As Long, L As Long
    Dim Buffer As String
  
    Drive = getDrive(Drive)
    If Drive = "" Then Exit Function

    Drive = CutDir(Drive)
    
    Buffer = Space(255)
    L = Len(Buffer)
    Result = WNetGetConnection(Drive, Buffer, L)

    If Result = 0 Then
        Get_FullNetPath = Left$(Buffer, L)
        Get_FullNetPath = Replace(Get_FullNetPath, Chr$(0), "")
        Get_FullNetPath = Trim$(Get_FullNetPath)
    End If
    
End Function
Public Function Get_SerialNumber(ByVal Drive As String) As String
    Dim DI As DRIVEINFO
    
    DI = Get_DriveInfo(Drive)
    
    Get_SerialNumber = DI.Serial
    
End Function
Public Function Get_DriveLabel(ByVal Drive As String) As String
    Dim DI As DRIVEINFO
    
    DI = Get_DriveInfo(Drive)

    Get_DriveLabel = DI.Label

End Function
Public Function Get_DriveFileSystem(ByVal Drive As String) As String
    Dim DI As DRIVEINFO
    
    DI = Get_DriveInfo(Drive)
    
    Get_DriveFileSystem = DI.FileSystem
    
End Function
