VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Forms"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function GradientFillRect Lib "msimg32" Alias "GradientFill" (ByVal hDC As Long, pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As GRADIENT_RECT, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function GetSystemMenu Lib "user32" (ByVal Hwnd As Long, ByVal bRevert As Long) As Long
Private Declare Function DrawMenuBar Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function SetClassLong Lib "user32" Alias "SetClassLongA" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal dwnewLong As Long) As Long
Private Declare Function LoadCursorFromFile Lib "user32.dll" Alias "LoadCursorFromFileA" (ByVal lpFileName As String) As Long
Private Declare Function AnimateWindow Lib "user32" (ByVal Hwnd As Long, ByVal dwTime As Long, ByVal dwFlags As Long) As Boolean
Private Declare Function GetClassLong Lib "user32" Alias "GetClassLongA" (ByVal Hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long

Public Type STANDARDBUTTONINFO
    sbiCLOSEBUTTONISVISIBLE As Boolean
    sbiMAXBUTTONISENABLED   As Boolean
    sbiMINBUTTONISENABLED   As Boolean
End Type

Public Type SIZEPAR
    xMin As Long
    yMin As Long
    xMax As Long
    yMax As Long
End Type

Public Enum FormOption
    ffFormName = 1
    ffFormCaption = 2
    ffFormTag = 4
End Enum

Private Type TRIVERTEX
    x     As Long
    Y     As Long
    Red   As Integer
    Green As Integer
    Blue  As Integer
    Alpha As Integer
End Type

Private Type GRADIENT_RECT
    UpperLeft  As Long
    LowerRight As Long
End Type

Public Enum cCenterInfo
    ccTOP = 1
    ccMIDDLE = 2
    ccBOTTOM = 3
    ccLEFT = 4
    ccRIGHT = 5
End Enum

Public Enum SystemButtons
    sbCLOSEBOX = 0
    sbMINIMIZEBOX = 1
    sbMAXIMIZEBOX = 2
    sbRESIZEABLE = 3
    sbBORDER = 4
    sbCONTROLBOX = 5
    sbSHOWINTASKBAR = 7
    sbMOVEABLE = 8
End Enum

Public Enum ANIMETNFO
    anFADEIN = 0
    anLEFT_TO_RIGHT = 1
    anUPPERLEFT_TO_LOWERRIGHT = 2
    anRIGHT_TO_LEFT = 3
    anUPERRIGHT_TO_LOWERLEFT = 4
    anUP_TO_DOWN = 5
    anDOWN_TO_UP = 6
    anMIDDLE = 7
    anFADEOUT = 8
    
    anSHRINK = 100
    anGROW = 101
End Enum

Private Const SM_CYCAPTION = &H4

Public Function Roll(Form As Object, xStart As Long, xEnd As Long, _
                     Optional Direction As ControlDirection = cdHorizontal, _
                     Optional RollSpeed As Long = 10) As Long
    
    Roll = DLL.CRTL.Control_Roll(Form, xStart, xEnd, Direction, RollSpeed)

End Function
Private Function CCol(ByVal Col As Byte) As Integer
    
    If Col > &H7F Then
        CCol = (Col * &H100&) - &H10000
    Else
        CCol = Col * &H100&
    End If

End Function
Public Function Fade(ByRef Form As Object, _
                     ByVal FadeFromColor As Long, ByVal FadeToColor As Long, Optional Alpha As Integer = 0, _
                     Optional Direction As ControlDirection = cdHorizontal) As Long
    Dim dwMode As Long, oldSm As Long
    Dim oldAr As Boolean
    Dim Vertex(0 To 1) As TRIVERTEX
    Dim RECT As GRADIENT_RECT
    Dim RGB As RGBtype
    
    Const GRADIENT_FILL_RECT_H = &H0
    Const GRADIENT_FILL_RECT_V = &H1

    On Local Error GoTo Quit
    
    oldSm = Form.ScaleMode
    oldAr = Form.AutoRedraw
    
    Form.ScaleMode = vbPixels
    Form.AutoRedraw = True
    
    If Direction = cdVertical Then
        dwMode = GRADIENT_FILL_RECT_H
    Else
        dwMode = GRADIENT_FILL_RECT_V
    End If
    
    RGB = DLL.GRAFX.Convert_ColorToRGB(FadeFromColor)
    
    With Vertex(0)
        .x = 0
        .Y = 0
        .Red = CCol(RGB.R)
        .Green = CCol(RGB.G)
        .Blue = CCol(RGB.B)
        .Alpha = Alpha
    End With

    RGB = DLL.GRAFX.Convert_ColorToRGB(FadeToColor)

    With Vertex(1)
        .x = Form.ScaleWidth
        .Y = Form.ScaleHeight
        .Red = CCol(RGB.R)
        .Green = CCol(RGB.G)
        .Blue = CCol(RGB.B)
        .Alpha = Alpha
    End With

    RECT.UpperLeft = 1
    RECT.LowerRight = 0
    
    Call GradientFillRect(Form.hDC, Vertex(0), 2, RECT, 1, dwMode)
    
Quit:
    If Err.Number <> 0 Then
        Fade = Err.Number

        Call ERROR(Forms_, "Fade", Err.Number, Err.Description)
    End If
    
    Form.Refresh
    
    Form.ScaleMode = oldSm
    Form.AutoRedraw = oldAr

    DoEvents

    Err.Clear
    
End Function
Public Function CloseBox_Deaktivate(Form As Variant) As Boolean
    Dim MI As MNUINFO
    Dim hMenu As Long, Hwnd As Long
    
    Hwnd = GetHwnd(Form)
    
    hMenu = GetSystemMenu(Hwnd, 0)
   
    If hMenu Then
        MI = DLL.Menu.Find_MenuItemByCaption(Hwnd, "&Schlieen" & Chr$(9) & "Alt+F4", True)
        
        If MI.Position = 0 Then MI = DLL.Menu.Find_MenuItemByCaption(Hwnd, "&Schlieen", True)
        
        Call RemoveMenuA(MI.mHwnd, MI.Position, MF_REMOVE Or MF_BYPOSITION)
        
        Call DrawMenuBar(Hwnd)
        Call Update(Hwnd)
        
        CloseBox_Deaktivate = True
    End If

End Function
Public Function Move(Form As Object, _
                     Optional ByVal xPos As Long = 0, Optional ByVal yPos As Long = 0, _
                     Optional Speed As Long = 1) As Long
    Dim P As Long
    Dim xStep As Integer, yStep As Integer
    
    On Local Error GoTo Quit
    
    xStep = 1
    yStep = 1
    
    If xPos < Form.Left Then xStep = -1
    If yPos < Form.Top Then yStep = -1
     
    If Speed < 0 Then Speed = Speed * (-1)
    
    If Speed = 0 Then
        Form.Left = xPos
        Form.Top = yPos
        
        Exit Function
    End If
    
    For P = Form.Left To xPos Step xStep
        Form.Left = P
        Form.Refresh
        
        Wait Speed
    Next P
    
    For P = Form.Top To yPos Step yStep
        Form.Top = P
        Form.Refresh
        
        Wait Speed
    Next P
    
    Exit Function
    
Quit:
    Move = Err.Number

    Call ERROR(Forms_, "Move", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Fade_Ranomized(Form As Object, _
                              Optional Direction As ControlDirection = cdHorizontal) _
                                        As Long
    Dim C1 As Long, C2 As Long
    
    On Local Error GoTo Quit
    
    Do While C1 = C2
        C1 = DLL.GRAFX.Get_RandomizedColor
        C2 = DLL.GRAFX.Get_RandomizedColor
    Loop
    
    Fade_Ranomized = Fade(Form, C1, C2, , Direction)

    Exit Function
    
Quit:
    Fade_Ranomized = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Forms_, "Fade_Ranomized", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Find_Form(pForms As Object, ByVal Find As String, _
                          FindIn As FormOption, Optional frm As Object, _
                          Optional FindExact As Boolean = True, _
                          Optional ErrorNumber As Long) As Long
    Dim P As Long, MustBe As Long, Ok As Long
    Dim R$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    MustBe = 0

    If FindIn And ffFormName Then MustBe = 1
    If FindIn And ffFormCaption Then MustBe = MustBe + 1
    If FindIn And ffFormTag Then MustBe = MustBe + 1
    
    If Not FindExact Then Find = LCase$(Find)
    
    For P = 0 To pForms.Count - 1
        Ok = 0
        
        If FindIn And ffFormName Then
            R$ = IIf(FindExact, pForms(P).Name, LCase$(pForms(P).Name))
            If R$ = Find Then Ok = 1
        End If
        
        If FindIn And ffFormCaption Then
            R$ = IIf(FindExact, pForms(P).Caption, LCase$(pForms(P).Caption))
            If R$ = Find Then Ok = Ok + 1
        End If
        
        If FindIn And ffFormTag Then
            R$ = IIf(FindExact, pForms(P).Tag, LCase$(pForms(P).Tag))
            If R$ = Find Then Ok = Ok + 1
        End If
        
        If Ok >= MustBe Then
            Find_Form = P
            
            Set frm = pForms(P)
            
            Exit Function
        End If
    Next P
    
    Find_Form = -1

Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        Find_Form = -2
        
        Call ERROR(Forms_, "Find_Form", Err.Number, Err.Description)
    End If
    
    Set frm = Nothing
    
    Err.Clear
    
End Function
Public Function StayOnTop(Form As Object, Optional ErrorNumber As Long) As Boolean
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    StayOnTop = DLL.WINDOW.StayOnTop(Form.Hwnd, False)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Forms_, "Center", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Center(Form As Object, CenterWhere As cCenterInfo) As Long
    Dim L As Long, T As Long
    Dim CD As CONTROLPOSITION
    
    On Local Error GoTo Quit

    Select Case CenterWhere
        Case ccTOP
            T = 0
        Case ccBOTTOM
            Call DLL.DESKTOP.Get_TaskbarPos(CD)
            T = CD.Top * vbContainerPosition
        Case ccLEFT
            L = 0
        Case ccRIGHT
            L = Screen.Width - Form.Width
        Case ccMIDDLE
            T = (Screen.Height / 2) - (Form.Height / 2)

        Case Else
            Exit Function
    End Select

    Select Case CenterWhere
        Case ccTOP, ccBOTTOM, ccMIDDLE
            L = ((Screen.Width / 2) - (Form.Width / 2))

            Form.Left = L
            Form.Top = T
        Case ccLEFT, ccRIGHT
            T = (Screen.Height / 2) - (Form.Height / 2)
        
            Form.Left = L
            Form.Top = T
    End Select
    
    Form.Refresh
    DoEvents
    
    Exit Function
    
Quit:
    Center = Err.Number

    Call ERROR(Forms_, "Center", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Set_XPstyle(Form As Object, Optional ApplyStyle As Boolean = True) As Long
    Dim C As Control
    
    On Local Error GoTo Quit
    
    If Not DLL.SYSTEM.XPstyleSupported Then
        Set_XPstyle = -1
        Exit Function
    End If
    
    Call DLL.WINDOW.Set_XPstyle(Form.Hwnd, ApplyStyle)
        
    For Each C In Form
        On Local Error Resume Next
        Call DLL.WINDOW.Set_XPstyle(C.Hwnd)
    Next C
       
    Err.Clear
    
Quit:
    Set_XPstyle = Err.Number

    If Err.Number <> 0 Then Call ERROR(Forms_, "Set_XPstyle", Err.Number, Err.Description, Form.Name)

    Set C = Nothing
    
    Err.Clear
    
End Function
Public Function Tile(Form As Object, Picture As StdPicture) As Long
    Dim x As Long, Y As Long, nWidth As Long, nHeight As Long
    
    On Local Error GoTo Quit
  
    With Form
        nWidth = .ScaleX(Picture.Width, 8, .ScaleMode)
        nHeight = .ScaleY(Picture.Height, 8, .ScaleMode)
    
        .AutoRedraw = True
        .Cls
    
        For x = 0 To .ScaleWidth Step nWidth
            For Y = 0 To .ScaleHeight Step nHeight
                .PaintPicture Picture, x, Y
            Next Y
        Next x
    
        .Picture = .Image
        .AutoRedraw = False
    End With
    
    Exit Function
    
Quit:
    Tile = Err.Number

    Call ERROR(Forms_, "Tile", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function tFade(Form As Object, _
                      ByVal FadeStart As Byte, ByVal FadeStop As Byte, _
                      Optional StartAtCurrentTransparenz As Boolean = False, _
                      Optional FadeStep As Integer = 5, _
                      Optional Speed As Integer = 10) As Long
        
    On Local Error GoTo Quit
    
    Call DLL.WINDOW.tFade(Form.Hwnd, FadeStart, FadeStop, StartAtCurrentTransparenz, FadeStep, Speed)

Quit:
    tFade = Err.Number

    If Err.Number <> 0 Then Call ERROR(FORMS, "tFade_", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function FormMove(Form As Object) As Long

    Const HTCAPTION = 2

    On Local Error GoTo Quit
    
    Call ReleaseCapture
    Call SendMessage(Form.Hwnd, WM_NCLBUTTONDOWN, HTCAPTION, 0&)

    Exit Function

Quit:
    FormMove = Err.Number
    
    Call ERROR(Forms_, "FormMove", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function CreateFormFromPicture(Form As Object, Picture As Object, _
                                      Optional PictureFile As String = "") As Long
    
    CreateFormFromPicture = CFFP(Form, Picture, PictureFile)

End Function
Public Function FormPos_Save(Form As Object, INIpath As String) As Long
        
    On Local Error GoTo Quit
    
    Call DLL.INI.Write_INI(INIpath, Form.Name, "Left", Form.Left)
    Call DLL.INI.Write_INI(INIpath, Form.Name, "Top", Form.Top)
    Call DLL.INI.Write_INI(INIpath, Form.Name, "Width", Form.Width)
    Call DLL.INI.Write_INI(INIpath, Form.Name, "Height", Form.Height)
    
    Exit Function
    
Quit:
    FormPos_Save = Err.Number

    Call ERROR(Forms_, "FormPos_Save", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function FormPos_Load(Form As Object, INIpath As String) As Long
        
    On Local Error GoTo Quit
    
    Form.Left = DLL.INI.Read_INI(INIpath, Form.Name, "Left")
    Form.Top = DLL.INI.Read_INI(INIpath, Form.Name, "Top")
    Form.Width = DLL.INI.Read_INI(INIpath, Form.Name, "Width")
    Form.Height = DLL.INI.Read_INI(INIpath, Form.Name, "Height")

    Exit Function

Quit:
    FormPos_Load = Err.Number

    Call ERROR(Forms_, "FormPos_Load", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Form(ByVal sForm As Object, But As SystemButtons, _
                     Optional Enable As Boolean = True) As Long
    Dim M As String
    Dim STYLE As Long, lngStyle As Long, xStyle As Long
    Dim nVisible As Boolean
    
    Const WS_SIZEBOX = &H40000

    On Local Error GoTo Quit

    xStyle = GWL_STYLE
    M = ""

    Select Case But
        Case sbCLOSEBOX
            Call CloseBox_Deaktivate(sForm)
            Exit Function
        Case sbMAXIMIZEBOX
            STYLE = WS_MAXIMIZEBOX
            M = "Ma&ximieren"
        Case sbMINIMIZEBOX
            STYLE = WS_MINIMIZEBOX
            M = "Mi&nimieren"
        Case sbRESIZEABLE
            STYLE = WS_SIZEBOX
        Case sbBORDER
            STYLE = WS_CAPTION
        Case sbCONTROLBOX
            STYLE = WS_SYSMENU
        Case sbSHOWINTASKBAR
            STYLE = WS_EX_APPWINDOW
            xStyle = GWL_EXSTYLE
        Case sbMOVEABLE
            Form = DLL.Menu.Remove_MenuByCaption(sForm.Hwnd, "&Verschieben", True)
            Exit Function
        Case Else
            Exit Function
    End Select

    lngStyle = GetWindowLongA(sForm.Hwnd, xStyle)
    
    Select Case xStyle
        Case GWL_STYLE
            lngStyle = IIf(Enable, lngStyle Or STYLE, lngStyle - STYLE)
                         
            Call SetWindowLong(sForm.Hwnd, GWL_STYLE, lngStyle)
            
            If Len(M) Then Form = DLL.Menu.Remove_MenuByCaption(sForm.Hwnd, M, True)
                   
            Call Update(sForm)
        Case GWL_EXSTYLE
            nVisible = sForm.Visible
            sForm.Visible = False
                              
            lngStyle = IIf(Enable, lngStyle Or STYLE, lngStyle And Not STYLE)
        
            Call SetWindowLong(sForm.Hwnd, GWL_EXSTYLE, lngStyle)
            
            sForm.Refresh
            sForm.Visible = nVisible
    End Select

    Exit Function

Quit:
    Form = Err.Number

    If Err.Number <> 0 Then Call ERROR(Forms_, "Form", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function ShowControlsOnly(Form As Object, Optional ErrorNumber As Long) As Boolean
    Dim Hwnd As Long, DstRgn As Long, TmpRgn As Long
    Dim MaxH As Long, MaxW As Long, H As Long, AlterScaleMode As Long
    Dim CL As Long, Ct As Long, ch As Long, Cw As Long
    Dim FrameX As Long, FrameY As Long, Caption As Long
    Dim cmd As Control
    
    Const SM_CXFRAME = &H20
    Const SM_CYFRAME = &H21

    On Local Error GoTo Quit
    
    Hwnd = Form.Hwnd
    
    DstRgn = CreateRectRgn(0, 0, 0, 0)
    
    AlterScaleMode = Form.ScaleMode
    Form.ScaleMode = vbPixels
  
    If Form.BorderStyle <> vbBSNone Then
        FrameX = GetSystemMetrics(SM_CXFRAME)
        FrameY = GetSystemMetrics(SM_CYFRAME)
        Caption = GetSystemMetrics(SM_CYCAPTION)
    End If
    
    For Each cmd In Form.Controls
        If Not TypeName(cmd) = "Menu" Then
            H = 0
            
            On Local Error Resume Next
            
            H = GetParentA(cmd.Hwnd)
            Err.Clear
            
            On Local Error GoTo Quit
            
            If H = 0 Or H = Hwnd Then
                CL = cmd.Left + FrameY
                Ct = cmd.Top + Caption + FrameX
                ch = cmd.Height
                Cw = cmd.Width
            
                TmpRgn = CreateRectRgn(CL, Ct, CL + Cw, Ct + ch)
            
                If MaxH < Ct + ch Then MaxH = Ct + ch
                If MaxW < CL + Cw Then MaxW = CL + Cw

                Call CombineRgn(DstRgn, DstRgn, TmpRgn, RGN_OR)
                Call DeleteObject(TmpRgn)
            End If
        End If
    Next
  
    Call SetWindowRgn(Hwnd, DstRgn, True)
    Call DeleteObject(DstRgn)
    
    Form.ScaleMode = AlterScaleMode
    Form.Height = (MaxH + FrameY) * Screen.TwipsPerPixelY
    Form.Width = (MaxW + FrameX) * Screen.TwipsPerPixelX
    
    ShowControlsOnly = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(Forms_, "ShowControlsOnly", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Sub Update(Form As Variant)
    Dim Hwnd As Long
    Dim R As RECT
    
    Hwnd = GetHwnd(Form)
    
    Call GetWindowRect(Hwnd, R)
    Call SetWindowPos(Hwnd, 0, R.Left, R.Top, R.Right - R.Left, R.Bottom - R.Top, SWP_FRAMECHANGED)
                      
End Sub
Public Function ScrollCaption(Form As Object, Optional Speed As Long = 1) As Long
    Dim Index As Long
    
    On Local Error GoTo Quit
    
    Index = DLL.FORMS.Find_Form(FORMS, "ScrollCaption", ffFormTag, , True)
    
    If Index = -1 Then
        Load MyControls
        MyControls.Tag = "ScrollCaption"
        Index = 0
    End If
    
    ScrollCaption = FORMS(Index).SetScrollCaption(Form, Speed)
    
Quit:
    ScrollCaption = Err.Number
    
    If Err.Number <> 0 Then
        If FORMS(Index).Timer_ScrollCaption.UBound = 0 Then Unload FORMS(Index)
        
        Call ERROR(Forms_, "ScrollCaption", Err.Number, Err.Description)
    End If
    
    Err.Clear
    
End Function
Public Function IsModal(Form As Object) As Boolean
        
    On Error Resume Next
  
    Form.Show
    IsModal = (Err.Number = 401)
  
    Err.Clear
  
End Function
Public Function ShowAnimatedCursor(Form As Object, ByVal CursorFile As String) As Long
    Dim hCursor As Long
    
    Const GCW_HCURSOR = -12

    On Local Error GoTo Quit
    
    hCursor = LoadCursorFromFile(CursorFile)
    
    If hCursor <> 0 Then
        Form.MousePointer = 99
        Call SetClassLong(Form.Hwnd, GCW_HCURSOR, hCursor)
    End If

    Exit Function

Quit:
    ShowAnimatedCursor = Err.Number

    Call ERROR(Forms_, "ShowAnimatedCursor", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function ShowSysMenu(Form As Object) As Long
    Dim IParam As Long
    Dim POS As Position
    
    Const WM_GETSYSMENU = &H313

    On Local Error GoTo Quit
    
    POS = DLL.HARDWARE.Mouse_GetPos

    IParam = (POS.Y * &H10000) Or (POS.x And &HFFFF&)
    
    Call SendMessage(Form.Hwnd, WM_GETSYSMENU, 0, ByVal IParam)

    Exit Function

Quit:
    ShowSysMenu = Err.Number

    Call ERROR(Forms_, "ShowSysMenu", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Sub Get_NonClientHeight(NormalWindow As Long, ToolWindow As Long)

    Const SM_CYSMCAPTION = 51

    ToolWindow = GetSystemMetrics(SM_CYSMCAPTION)
    NormalWindow = GetSystemMetrics(SM_CYCAPTION)

End Sub
Public Function Animate(Form As Object, AniTyp As ANIMETNFO, _
                        Optional Speed As Long = 5) As Long
    Dim Ani As Long, x As Long, Y As Long, lngFormWidth As Long, lngFormHeight As Long
    Dim blnFullWidth As Boolean, blnFullHeight As Boolean, oAR As Boolean

    Const STEPS As Long = 255

    On Local Error GoTo Quit
    
    oAR = Form.AutoRedraw
    Form.AutoRedraw = True
    
    If AniTyp < 100 Then
        Select Case AniTyp
            Case anFADEIN:                  Ani = 524288
            Case anDOWN_TO_UP:              Ani = 262152
            Case anLEFT_TO_RIGHT:           Ani = 262145
            Case anUPPERLEFT_TO_LOWERRIGHT: Ani = 5
            Case anMIDDLE:                  Ani = 16
            Case anRIGHT_TO_LEFT:           Ani = 262146
            Case anUPERRIGHT_TO_LOWERLEFT:  Ani = 6
            Case anUP_TO_DOWN:              Ani = 262148
            Case anFADEOUT:                 Ani = 589824
        End Select
    
        Call AnimateWindow(Form.Hwnd, (Speed * 100), Ani)
    
        Form.Refresh
    
        GoTo Quit
    End If
    
    With Form
        If .WINDOWSTATE = vbMaximized Then
            .WINDOWSTATE = vbNormal
            .Width = Screen.Width
            .Height = Screen.Height
        End If
    
        lngFormWidth = .Width
        lngFormHeight = .Height
    
        If AniTyp = anGROW Then
            x = 0: Y = 0
      
            .Width = 0
            .Height = 0
            
            .Move (Screen.Width - .Width) / 2, (Screen.Height - .Height) / 2, x, Y
            .Show
            
            DoEvents
      
            blnFullWidth = False
            blnFullHeight = False
      
            Do While Not (blnFullWidth And blnFullHeight)
                .Move (Screen.Width - .Width) / 2, (Screen.Height - .Height) / 2, x, Y
                
                Wait (Speed * 100)
                               
                If x <= lngFormWidth Then x = x + STEPS Else blnFullWidth = True
                If Y <= lngFormHeight Then Y = Y + STEPS Else blnFullHeight = True
            Loop

            .Move (Screen.Width - .Width) / 2, (Screen.Height - .Height) / 2, lngFormWidth, lngFormHeight
            DoEvents
        Else
            x = lngFormWidth
            Y = lngFormHeight
      
            DoEvents
         
            blnFullWidth = False
            blnFullHeight = False
      
            Do While Not (blnFullWidth And blnFullHeight)
                .Move .Left, .Top, x, Y
                 
                Wait (Speed * 100)
                
                If x <= lngFormWidth Then
                    x = x - STEPS
                    
                    If x < 0 Then
                        x = 0
                        blnFullWidth = True
                    End If
                End If
        
                If Y <= lngFormHeight Then
                    Y = Y - STEPS
        
                    If Y < 0 Then
                        Y = 0
            
                        blnFullHeight = True
                    End If
                End If
            Loop
        End If
    End With

Quit:
    Form.AutoRedraw = oAR
    
    Animate = Err.Number

    If Err.Number <> 0 Then Call ERROR(Forms_, "Animate", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Set_WindowShadow(ByVal Form As Object) As Long
  
    Const CS_DROPSHADOW = &H20000
    Const GCL_STYLE = (-26)

    On Local Error GoTo Quit
  
    Call SetClassLong(Form.Hwnd, GCL_STYLE, GetClassLong(Form.Hwnd, GCL_STYLE) Or CS_DROPSHADOW)
  
    Form.Refresh
    DoEvents
    
    Exit Function
  
Quit:
    Set_WindowShadow = Err.Number

    Call ERROR(Forms_, "Set_WindowShadow", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Get_Transparenz(Form As Object, Optional ErrorNumber As Long) As Long
    
    On Local Error GoTo Quit
    
    Get_Transparenz = DLL.WINDOW.Get_Transparenz(Form.Hwnd)

    Exit Function

Quit:
    ErrorNumber = Err.Number
    Get_Transparenz = -2
    
    Call ERROR(Forms_, "Get_Transparenz", Err.Number, Err.Description)
        
    Err.Clear
    
End Function
Public Function Set_Transparenz(Form As Object, Transparenz As Byte) As Long

    On Local Error GoTo Quit

    Call DLL.WINDOW.Set_Transparenz(Form.Hwnd, Transparenz)
    
    Exit Function
    
Quit:
    Set_Transparenz = Err.Number
    
    Call ERROR(Forms_, "Get_Transparenz", Err.Number, Err.Description)
        
    Err.Clear

End Function
Public Function Form_Save(Form As Object, ByVal INIpath As String) As Boolean
    Dim i As String, F As String, x As Long
    Dim Crt As Control
    
    If Not TypeOf Form Is Form Then Exit Function
        
    On Local Error Resume Next
    x = Form.Index
    
    If Err.Number <> 0 Then
        F = Form.Name
    Else
        F = F = Form.Name & "(" & x & ")"
    End If
    
    Err.Clear
    
    i = INIpath
    
    Call DLL.FORMS.FormPos_Save(Form, i)
    
    Call DLL.INI.Write_INI(i, F, "Appearance", Form.Appearance)
    Call DLL.INI.Write_INI(i, F, "AutoRedraw", Form.AutoRedraw)
    Call DLL.INI.Write_INI(i, F, "BackColor", Form.BackColor)
    Call DLL.INI.Write_INI(i, F, "BorderStyle", Form.BorderStyle)
    Call DLL.INI.Write_INI(i, F, "Caption", Form.Caption)
    Call DLL.INI.Write_INI(i, F, "Enabled", Form.Enabled)
    Call DLL.INI.Write_INI(i, F, "ForeColor", Form.ForeColor)
    Call DLL.INI.Write_INI(i, F, "ScaleMode", Form.ScaleMode)
    Call DLL.INI.Write_INI(i, F, "Tag", Form.Tag)
    Call DLL.INI.Write_INI(i, F, "Visible", Form.Visible)
    
    For Each Crt In Form
        Call DLL.CRTL.Control_Save(Crt, Form, i)
    Next Crt
    
    Form_Save = True
    
End Function
Public Function Form_Load(Form As Object, ByVal INIpath As String) As Boolean
    Dim i As String, F As String
    Dim Crt As Control
    
    If Not TypeOf Form Is Form Then Exit Function
    If Not DLL.File.Exist(INIpath) Then Exit Function
    
    i = INIpath
    F = Form.Name
    
    Call DLL.FORMS.FormPos_Load(Form, i)
    
    Form.Appearance = DLL.INI.Read_INI(i, F, "Appearance")
    Form.AutoRedraw = CBool(DLL.INI.Read_INI(i, F, "AutoRedraw"))
    Form.BackColor = DLL.INI.Read_INI(i, F, "BackColor")
    Form.BorderStyle = DLL.INI.Read_INI(i, F, "BorderStyle")
    Form.Caption = DLL.INI.Read_INI(i, F, "Caption")
    Form.Enabled = CBool(DLL.INI.Read_INI(i, F, "Enabled"))
    Form.ForeColor = DLL.INI.Read_INI(i, F, "ForeColor")
    Form.ScaleMode = DLL.INI.Read_INI(i, F, "ScaleMode")
    Form.Tag = DLL.INI.Read_INI(i, F, "Tag")
    Form.Visible = CBool(DLL.INI.Read_INI(i, F, "Visible"))
    
    For Each Crt In Form
        Call DLL.CRTL.Control_Load(Crt, Form, i)
    Next Crt
    
    Form_Load = True
    
End Function
Public Sub Form_LimitSize(frm As Object, SP As SIZEPAR)

    If Not TypeOf frm Is Form Then Exit Sub

    Call basFrmLimit.InitFrmLimit(frm, SP)

End Sub
Public Function RemoveSystemmenu(frm As Variant) As Long
    Dim mHwnd As Long, MenuItems As Long, P As Long, Hwnd As Long
    
    On Local Error GoTo Quit
    
    Hwnd = GetHwnd(frm)
    
    mHwnd = DLL.Menu.Get_SystemMenuHwnd(Hwnd)
    
    If mHwnd <> 0 Then
        MenuItems = GetMenuItemCountA(mHwnd)
        
        If MenuItems <> 0 Then
            For P = (MenuItems - 1) To 0 Step -1
                Call RemoveMenuA(mHwnd, P, MF_BYPOSITION)
            Next P
        Else
            RemoveSystemmenu = -2
        End If
    Else
        RemoveSystemmenu = -1
    End If
    
    Exit Function
    
Quit:
    RemoveSystemmenu = Err.Number
    
    Call ERROR(Forms_, "RemoveSystemmenu", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Sub MinMaxDeaktivat(frm As Variant)
    Dim Hwnd As Long
    
    Hwnd = GetHwnd(frm)

    Call DLL.Menu.Remove_MenuByCaption(Hwnd, "Mi&nimieren", True)
    Call DLL.Menu.Remove_MenuByCaption(Hwnd, "Ma&ximieren", True)

    Call basFrmDeaktivatMinMax.Init(Hwnd)
    
End Sub
Public Sub MinMaxShow(frm As Variant, ByVal ShowMinMax As Boolean)
    Dim Hwnd As Long
    
    Hwnd = GetHwnd(frm)
    
    Call SetForm(Hwnd, ShowMinMax, WS_MAXIMIZEBOX)
    Call SetForm(Hwnd, ShowMinMax, WS_MINIMIZEBOX)
    
End Sub
Public Sub CloseBox_Show(frm As Variant, ByVal ShowCloseBox As Boolean)
    Dim Hwnd As Long
    
    Hwnd = GetHwnd(frm)
    
    Call SetForm(Hwnd, ShowCloseBox, WS_SYSMENU)
    
End Sub
Public Sub TitleBar_Show(frm As Variant, ByVal ShowTitleBar As Boolean)
    Dim Hwnd As Long
    
    Hwnd = GetHwnd(frm)
    
    Call SetForm(Hwnd, ShowTitleBar, WS_BORDER)
    
End Sub
Private Sub SetForm(Hwnd As Long, Enabled As Boolean, _
                    ToggleStyle As Long)
    Dim lngStyle As Long
  
    lngStyle = GetWindowLong(Hwnd, GWL_STYLE)
    
    If Not Enabled Then
        lngStyle = lngStyle - ToggleStyle
    Else
        lngStyle = lngStyle Or ToggleStyle
    End If
    
    Call SetWindowLong(Hwnd, GWL_STYLE, lngStyle)
    Call Update(Hwnd)
    
End Sub
Public Function StandardButton(frm As Variant) As STANDARDBUTTONINFO
    Dim Hwnd As Long, STYLE As Long
    Dim SBI As STANDARDBUTTONINFO
    
    Hwnd = GetHwnd(frm)
    
    STYLE = GetWindowLongA(Hwnd, GWL_STYLE)

    With SBI
        .sbiCLOSEBUTTONISVISIBLE = CBool(STYLE And WS_SYSMENU) * -1
        .sbiMAXBUTTONISENABLED = CBool(STYLE And WS_MAXIMIZEBOX) * -1
        .sbiMINBUTTONISENABLED = CBool(STYLE And WS_MINIMIZEBOX) * -1
    End With

    StandardButton = SBI

End Function
Public Function ShakeForm(frm As Object, ByVal Amplitude As Long, _
                          ByVal MilliSeconds As Long, _
                          Optional ErrorNumber As Long) As Boolean
    Dim lngOriginalLeft As Long, lngOriginalTop As Long, x As Long, Y As Long
    Dim AnfangsZeit As Long, TickCount As Long
 
    On Local Error GoTo Quit
    
    Randomize Timer * Timer
    
    lngOriginalLeft = frm.Left
    lngOriginalTop = frm.Top
    AnfangsZeit = Amplitude
   
    Do While MilliSeconds >= 10
        frm.Left = lngOriginalLeft
        frm.Top = lngOriginalTop
     
        x = MilliSeconds / Amplitude
        Y = MilliSeconds / Amplitude
    
        Select Case Int((4) * Rnd + 1)
            Case 1: frm.Top = frm.Top - Y
            Case 2: frm.Top = frm.Top + Y
            Case 3: frm.Left = frm.Left + x
            Case 4: frm.Left = frm.Left - x
        End Select
     
        MilliSeconds = MilliSeconds - 10
        TickCount = GetTickCount
  
        While (TickCount + 10) > GetTickCount
            DoEvents
        Wend
    Loop
    
    ShakeForm = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(Forms_, "ShakeForm", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
