VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Hardware"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Type JOYCAPS
    wMid        As Integer
    wPid        As Integer
    szPname     As String * 32
    wXmin       As Long
    wXmax       As Long
    wYmin       As Long
    wYmax       As Long
    wZmin       As Long
    wZmax       As Long
    wNumButtons As Long
    wPeriodMin  As Long
    wPeriodMax  As Long
End Type

Private Declare Function SetPrinter Lib "winspool.drv" Alias "SetPrinterA" (ByVal hPrinter As Long, ByVal Level As Long, pPrinter As Byte, ByVal Command As Long) As Long
Private Declare Function OpenPrinter Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long, pDefault As PRINTER_DEFAULTS) As Long
Private Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long
Private Declare Function GetProfileString Lib "kernel32" Alias "GetProfileStringA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Private Declare Function ConfigurePort Lib "winspool.drv" Alias "ConfigurePortA" (ByVal pName As Any, ByVal hwnd As Long, ByVal pPortName As String) As Long
Private Declare Function joyGetDevCaps Lib "winmm.dll" Alias "joyGetDevCapsA" (ByVal id As Long, lpCaps As JOYCAPS, ByVal uSize As Long) As Long
Private Declare Function joyGetNumDevs Lib "winmm.dll" () As Long
Private Declare Function joyGetPos Lib "winmm.dll" (ByVal uJoyID As Long, pji As JOYINFO) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal x As Long, ByVal Y As Long) As Long
Private Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal x As Long, ByVal Y As Long) As Long
Private Declare Function BlockInput Lib "user32" (ByVal fBlock As Long) As Long
Private Declare Function Clip_Cursor Lib "user32" Alias "ClipCursor" (lpRect As Any) As Long
Private Declare Function PAGESETUPDLG Lib "comdlg32.dll" Alias "PageSetupDlgA" (pPagesetupdlg As PAGESETUPDLG) As Long
Private Declare Function waveOutGetNumDevs Lib "winmm" () As Long
Private Declare Function midiOutGetNumDevs Lib "winmm" () As Integer
Private Declare Function PdhOpenQuery Lib "PDH.DLL" (ByVal Reserved As Long, ByVal dwUserData As Long, ByRef hQuery As Long) As Long
Private Declare Function PdhVbAddCounter Lib "PDH.DLL" (ByVal QueryHandle As Long, ByVal CounterPath As String, ByRef CounterHandle As Long) As Long
Private Declare Function PdhCloseQuery Lib "PDH.DLL" (ByVal hQuery As Long) As Long
Private Declare Function PdhCollectQueryData Lib "PDH.DLL" (ByVal QueryHandle As Long) As Long
Private Declare Function PdhVbGetDoubleCounterValue Lib "PDH.DLL" (ByVal CounterHandle As Long, ByRef CounterStatus As Long) As Double

Private Declare Sub SetThreadExecutionState Lib "kernel32.dll" (ByRef esFlags As Long)
Private Declare Sub Mouse_event Lib "user32" (ByVal dwFlags As Long, ByVal dx As Long, ByVal dy As Long, ByVal cButtons As Long, ByVal dwExtraInfo As Long)

Public Type CPUINFO
    DeviceID          As String
    CPUname           As String
    MaxClockSpeed     As Long
    ProcessorID       As String
    CurrentClockSpeed As Long
    L2Cache           As String
    CurrentVoltage    As Long
    Description       As String
    Manufacturer      As String
    SocketDesignation As String
    Status            As String
    Family            As String
    Version           As String
    StatusInfo        As String
    ProcessorType     As String
End Type

Public Type MainboardInfo
    Caption      As String
    Manufacturer As String
    Product      As String
    Version      As String
End Type

Public Type VideoAdapterInfo
    AdapterCompatibility    As String
    AdapterRAM              As String
    Caption                 As String
    DeviceID                As String
    DRIVERVERSION           As String
    InfFilename             As String
    InfSection              As String
    InstalledDisplayDrivers As String
    PNPDeviceID             As String
    Status                  As String
    VideoProcessor          As String
    VideoMemoryType         As String
    Availability            As String
    VideoArchitecture       As String
End Type

Public Type PRINTERINFO
    Name      As String
    SPOOLER   As String
    INTERFACE As String
End Type

Public Type PRINTEREXINFO
    Name            As String
    DRIVERVERSION   As String
    TECHNOLOGY      As String
    Width_in_mm     As String
    Height_in_mm    As String
    Width_in_Pixel  As String
    Height_in_Pixel As String
    DPI_in_X        As String
    DPI_in_Y        As String
    Brushes         As String
    Pens            As String
    Colors          As String
End Type

Public Type Position
    x As Long
    Y As Long
End Type

Public Type JOYSTICKINFO
    Buttons       As Long
    PressedButton As Long
    X_Max         As Long
    Y_Max         As Long
    Z_Max         As Long
    X_Min         As Long
    Y_Min         As Long
    Z_Min         As Long
    x             As Long
    Y             As Long
    Z             As Long
End Type

Private Type PAGESETUPDLG
    lStructSize             As Long
    hWndOwner               As Long
    hDevMode                As Long
    hDevNames               As Long
    Flags                   As Long
    ptPaperSize             As POINTAPI
    rtMinMargin             As RECT
    rtMargin                As RECT
    hInstance               As Long
    lCustData               As Long
    lpfnPageSetupHook       As Long
    lpfnPagePaintHook       As Long
    lpPageSetupTemplateName As String
    hPageSetupTemplate      As Long
End Type

Private Type JOYINFO
    x       As Long
    Y       As Long
    Z       As Long
    Buttons As Long
End Type

Public Enum MonitorCommand
    mcActivate = 1
    mcDeactivate = 0
End Enum

Public Enum PRINTERCOMMAND
    prtSTOP = 1
    prtRESUME = 2
    prtJOBCANCEL = 3
End Enum

Public Enum prtGetNFO
    PrtName = 1
    prtDRIVER = 2
    prtPORT = 3
End Enum

Private Type PRINTER_DEFAULTS
     pDatatype     As Long
     pDevMode      As Long
     DesiredAccess As Long
End Type

Private Const JOYERR_NOERROR = (0)

Private Const PRINTER_ACCESS_ADMINISTER As Long = &H4
Private Const PRINTER_ACCESS_USE As Long = &H8
Private Const PRINTER_ALL_ACCESS As Long = (STANDARD_RIGHTS_REQUIRED Or PRINTER_ACCESS_ADMINISTER Or PRINTER_ACCESS_USE)

Private m_StackSize As Long, hQuery As Long, StackPointer As Long, Retval As Long, hCounter As Long, m_BandWidth As Long
Private Stack() As Long, m_Sum As Long

Public Function Printer_SetCommand(ByVal Command As PRINTERCOMMAND, _
                                   Optional ErrorNumber As Long) As Boolean
    Dim pName As String
    Dim hPrinter As Long
    Dim pd As PRINTER_DEFAULTS
  
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    pd.DesiredAccess = PRINTER_ALL_ACCESS
    pName = Printer.DeviceName
    
    If OpenPrinter(pName, hPrinter, pd) Then
        If SetPrinter(hPrinter, 0, vbNull, Command) Then
            Call ClosePrinter(hPrinter)
            Printer_SetCommand = True
        End If
    End If
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(HARDWARE, "Printer_SetCommand", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Printer_Default() As PRINTERINFO
    Dim Buffer As String
    Dim R As Long, x As Long, Y As Long
    Dim PI As PRINTERINFO
    
    Buffer = Space(8192)
    
    R = GetProfileString("windows", "Device", "", Buffer, Len(Buffer))
    
    If R Then
        Buffer = mID$(Buffer, 1, R)
        x = InStr(Buffer, ",")
        Y = InStr(x + 1, Buffer, ",")
        
        With PI
            .Name = mID$(Buffer, 1, x - 1)
            .SPOOLER = mID$(Buffer, x + 1, Y - x - 1)
            .INTERFACE = mID$(Buffer, Y + 1)
        End With
        
        Printer_Default = PI
    End If

End Function
Public Function Printer_List(Optional ErrorNumber As Long) As String()
    Dim P As Long
    Dim A() As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    ReDim A(Printers.Count - 1)
    
    For P = 0 To Printers.Count - 1
        A(P) = Printers(P).DeviceName
    Next P

    Printer_List = A
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(HARDWARE, "Printer_List", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Printer_Select(ByVal PrinterName As String, _
                               Optional ErrorNumber As Long) As Boolean
    Dim P As Long

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    For P = 0 To Printers.Count - 1
        If LCase(Printers(P).DeviceName) = LCase(PrinterName) Then
            Set Printer = Printers(P)
            Printer_Select = True
            Exit Function
        End If
    Next P
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(HARDWARE, "Printer_Select", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Printer_DeleteDocsFromQueue(Optional ByVal PrinterName As String) As Boolean
    Dim hPrinter As Variant
    Dim udtPrinter As PRINTER_DEFAULTS
  
    Const PRINTER_CONTROL_PURGE As Long = 3&

    If Len(PrinterName) = 0 Then PrinterName = Printer.DeviceName

    udtPrinter.DesiredAccess = PRINTER_ALL_ACCESS

    Call OpenPrinter(PrinterName, hPrinter, udtPrinter)
    
    If hPrinter Then
        Call SetPrinter(hPrinter, 0, vbNull, PRINTER_CONTROL_PURGE)
    
        Printer_DeleteDocsFromQueue = True
    End If
    
    Call ClosePrinter(hPrinter)
    
End Function
Public Function Printer_isAvaible() As Boolean
    Printer_isAvaible = (Printers.Count > 0)
End Function
Public Function COMport_Exist(ByVal Port As Long) As Boolean
    Dim F As Integer
    Dim sCOMParam As String

    On Local Error GoTo Quit

    sCOMParam = "COM" & CStr(Port) & ":9600,n,8,1"
    
    F = FreeFile
  
    Open sCOMParam For Input As #F
    Close #F
    
    COMport_Exist = True

    Exit Function
    
Quit:
    Err.Clear
    
End Function
Public Function COMport_ConfigureDialog(ByVal Port As Long, Optional hwnd As Long) As Long
    Dim sPort As String
    
    On Local Error GoTo Quit
    
    If COMport_Exist(Port) Then
        sPort = "COM" & Port & ":"
        
        Call ConfigurePort(vbNullString, hwnd, sPort)
    End If
    
    Exit Function
    
Quit:
    COMport_ConfigureDialog = Err.Number

    If Err.Number <> 0 Then Call ERROR(HARDWARE, "COMport_ConfigureDialog", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function COMport_GetInstalledCOMPorts() As String()
    Dim Port As Long, x As Long, P As Long
    Dim R$, A() As String, S() As String
    
    For Port = 1 To 16
        If COMport_Exist(Port) Then R$ = R$ & CStr(Port) & ","
    Next Port
    
    If Right$(R$, 1) = "," Then R$ = mID(R$, 1, Len(R$) - 1)
    
    A = Split(R$, ",")
    x = 0
    
    If UBound(A) > -1 Then
        For P = 0 To UBound(A)
            ReDim Preserve S(x)
            S(x) = A(P)
            
            x = x + 1
        Next P
    Else
        Erase S
    End If
    
    COMport_GetInstalledCOMPorts = S
    
End Function
Public Function Keyboard_CAPSisEnabled() As Boolean
    
    Keyboard_CAPSisEnabled = (GetKeyState(vbKeyCapital) = 1)

End Function
Public Function Keyboard_NUMisEnabled() As Boolean
    
    Keyboard_NUMisEnabled = (GetKeyState(vbKeyNumlock) = 1)

End Function
Public Function Keyboard_GetPressedKey() As Long
    Dim P As Long
    
    For P = 0 To 255
        If GetAsyncKeyState(P) = -32767 Then
            Keyboard_GetPressedKey = P
            
            Exit Function
        End If
    Next P

End Function
Public Function Keyboard_KeyIsPressed(ByVal Key As Variant) As Boolean
    Dim x As Integer, K As Integer
    
    On Local Error Resume Next
    
    x = Keyboard_GetPressedKey
    K = CInt(Key)
    
    If Err.Number <> 0 Then
        Err.Clear
        K = Asc(Key)
        
        If Err.Number <> 0 Then
            Err.Clear
            
            Exit Function
        End If
    End If
    
    If x = K Then Keyboard_KeyIsPressed = True

End Function
Public Function CPU_Speed() As Long
    Dim CI As CPUINFO
    
    CI = CPU_Info(0)
    CPU_Speed = CI.MaxClockSpeed
    
End Function
Public Function CPU_Info(ByVal Index As Long) As CPUINFO
    Dim objCPUItem As Object, objCPU As Object
    Dim CI As CPUINFO
    Dim x As Long
    
    Set objCPUItem = GetObject("winmgmts:").InstancesOf("Win32_Processor")
  
    For Each objCPU In objCPUItem
        If x = Index Then
            With CI
                .DeviceID = objCPU.DeviceID
                .CPUname = Trim$(objCPU.Name)
                .MaxClockSpeed = objCPU.MaxClockSpeed
                .ProcessorID = objCPU.ProcessorID
                .CurrentClockSpeed = objCPU.CurrentClockSpeed
                .CurrentVoltage = objCPU.CurrentVoltage
                .Description = objCPU.Description
                .Family = Get_ProcessorFamily(objCPU.Family)
                .L2Cache = objCPU.L2CacheSize
                .Manufacturer = objCPU.Manufacturer
                .ProcessorType = Get_ProcessorType(objCPU.ProcessorType)
                .SocketDesignation = objCPU.SocketDesignation
                .Status = objCPU.Status
                .StatusInfo = Get_ProcessorStatus(objCPU.StatusInfo)
                .Version = objCPU.Version
            End With
            
            CPU_Info = CI
            
            Exit For
        End If
        
        x = x + 1
    Next objCPU
      
    Set objCPUItem = Nothing
    Set objCPU = Nothing

End Function
Public Function CPU_Load() As Long
    Dim V As Long, pdhStatus As Long
    Dim dblValue As Double

    Const KDyn& = &H80000006
    Const PDH_CSTATUS_VALID_DATA = &H0
    Const PDH_CSTATUS_NEW_DATA = &H1

    Static Count As Long, hK As Long
    Static isNT As Boolean
    Static sK As String
    
    If Count = 0 Then
        isNT = DLL.SYSTEM.isWindowsNT
        
        m_StackSize = 5
        ReDim Stack(0 To m_StackSize - 1)
        StackPointer = 0
       
        If isNT Then
            Retval = PdhOpenQuery(0, 1, hQuery)
        
            If Retval = 0 Then
                Retval = PdhVbAddCounter(hQuery, "\Prozessor(0)\Prozessorzeit (%)", hCounter)
                If Retval <> 0 Then PdhCloseQuery hQuery
            End If
        End If

        m_StackSize = 10
        ReDim Stack(0 To m_StackSize - 1)
        StackPointer = 0
    
        Count = 1
    End If

    If isNT Then
        PdhCollectQueryData hQuery
        dblValue = PdhVbGetDoubleCounterValue(hCounter, pdhStatus)
        
        If (pdhStatus = PDH_CSTATUS_VALID_DATA) Or (pdhStatus = PDH_CSTATUS_NEW_DATA) Then PushBandWidth CLng(dblValue)
    Else
        'Mu noch unter 98 getestet werden !!!
        sK = IIf(hK = 0, "PerfStats\StartStat", "PerfStats\StatData")
        
        If Not DLL.REGISTRY.KeyExist(KDyn, sK) Then Exit Function

        V = DLL.REGISTRY.ValueGet(KDyn, sK & "\KERNEL", "CPUUsage")
               
        PushBandWidth V
    End If

    CPU_Load = m_BandWidth
   
End Function
Private Sub PushBandWidth(ByRef NewBandWidth As Long)
    
    Static U As Long
    
    U = UBound(Stack)
  
    If StackPointer <= U Then
        Stack(StackPointer) = NewBandWidth
        m_Sum = m_Sum + NewBandWidth
        StackPointer = StackPointer + 1
    Else
        m_Sum = m_Sum - Stack(0) + NewBandWidth
        Call CopyMemory(Stack(0), Stack(1), U * 4)
        Stack(U) = NewBandWidth
    End If
    
    m_BandWidth = m_Sum / StackPointer

End Sub
Public Function CPU_Count(Optional ErrorNumber As Long) As Long
    Dim objCPUItem As Object

    On Local Error GoTo Quit
  
    ErrorNumber = 0
    
    Set objCPUItem = GetObject("winmgmts:").InstancesOf("Win32_Processor")
  
    CPU_Count = CLng(Trim$(Str$(objCPUItem.Count)))

Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        
        Call ERROR(HARDWARE, "CPU_Count", Err.Number, Err.Description)
    End If
    
    Set objCPUItem = Nothing
    
    Err.Clear
    
End Function
Public Function Joystick_isPresent() As Boolean
    
    Joystick_isPresent = (Joystick_Count > 0)

End Function
Public Function Joystick_Count() As Long
    Dim i As Long, P As Long, x As Long
    Dim JI As JOYINFO
    
    i = joyGetNumDevs + 1
    
    For P = i To 0 Step -1
        If joyGetPos(P, JI) = JOYERR_NOERROR Then x = x + 1
    Next P
    
    Joystick_Count = x
    
End Function
Public Function Joystick_GetInfo(ByVal Index) As JOYSTICKINFO
    Dim Jc As JOYCAPS
    Dim JI As JOYINFO
    Dim j As JOYSTICKINFO
    
    If joyGetDevCaps(Index, Jc, Len(Jc)) <> JOYERR_NOERROR Then Exit Function
    If joyGetPos(Index, JI) <> JOYERR_NOERROR Then Exit Function

    With j
        .Buttons = Jc.wNumButtons
        .PressedButton = JI.Buttons
        .X_Max = Jc.wXmax
        .Y_Max = Jc.wYmax
        .Z_Max = Jc.wZmax
        .X_Min = Jc.wXmin
        .Y_Min = Jc.wYmin
        .Z_Min = Jc.wZmin
        .x = JI.x
        .Y = JI.Y
        .Z = JI.Z
    End With
    
    Joystick_GetInfo = j
 
End Function
Public Sub Monitor_PowerDown(ByVal hwnd As Long, Command As MonitorCommand)
    Dim lParam As Long
    
    Const SC_MONITORPOWER = &HF170&

    Select Case Command
        Case mcActivate:   lParam = 1
        Case mcDeactivate: lParam = 2
    End Select

    Call SendMessage(hwnd, WM_SYSCOMMAND, SC_MONITORPOWER, ByVal lParam)
    
End Sub
Public Sub Mouse_Click(Optional ClickRight As Boolean, _
                       Optional DoubleClick As Boolean = False)
    Dim P As Long
    
    Const MOUSEEVENTF_LEFTDOWN = &H2
    Const MOUSEEVENTF_LEFTUP = &H4
    Const MOUSEEVENTF_RIGHTDOWN = &H8
    Const MOUSEEVENTF_RIGHTUP = &H10

    If Not ClickRight Then
        For P = 1 To IIf(DoubleClick, 2, 1)
            Call Mouse_event(MOUSEEVENTF_LEFTDOWN Or MOUSEEVENTF_LEFTUP, 0&, 0&, CLng(0), CLng(0))
        Next P
    Else
        Call Mouse_event(MOUSEEVENTF_RIGHTDOWN Or MOUSEEVENTF_RIGHTUP, 0&, 0&, CLng(0), CLng(0))
    End If
    
End Sub
Public Function Mouse_SetPos(ByVal x As Long, ByVal Y As Long) As Boolean
    Dim Result As Long
    
    Result = SetCursorPos(x, Y)
    Mouse_SetPos = (Result <> 0)
    
End Function
Public Sub Mouse_Show(Optional ShowMouse As Boolean = False)
    Dim bShow As Long
    
    bShow = IIf(ShowMouse, 1, 0)
    
    Call ShowCursor(bShow)
    
End Sub
Public Function Mouse_hWndUnderCursor() As Long
    Dim nPoint As POINTAPI
    
    Call GetCursorPos(nPoint)
    Mouse_hWndUnderCursor = WindowFromPoint(nPoint.x, nPoint.Y)

End Function
Public Function Mouse_GetColorUnderCursor() As Long
    Dim Hdcp As Long, hwnd As Long
    Dim nPoint As POINTAPI
    
    Call GetCursorPos(nPoint)
    
    hwnd = WindowFromPoint(nPoint.x, nPoint.Y)
    Hdcp = GetDC(hwnd)
    
    Call ScreenToClient(hwnd, nPoint)
    Mouse_GetColorUnderCursor = GetPixel(Hdcp, nPoint.x, nPoint.Y)

End Function
Public Function Mouse_GetPos() As Position
    Dim PA As POINTAPI
    
    Call GetCursorPos(PA)
    
    Mouse_GetPos.x = PA.x
    Mouse_GetPos.Y = PA.Y
    
End Function
Public Function Mouse_GetTextUnderCursor() As String
    
    Mouse_GetTextUnderCursor = DLL.WINDOW.Get_Text(Mouse_hWndUnderCursor)

End Function
Public Function Mouse_GetClassUnderCursor() As String
    
    Mouse_GetClassUnderCursor = DLL.WINDOW.Get_Class(Mouse_hWndUnderCursor)

End Function
Public Function Mouse_isCursorOverHwnd(ByVal hwnd As Long) As Boolean
    
    Mouse_isCursorOverHwnd = (Mouse_hWndUnderCursor = hwnd)

End Function
Public Function Mouse_isUserClick(ByVal hwnd As Long) As Boolean
    Dim nPoint As POINTAPI
    
    Const VK_LBUTTON = &H1

    Call GetCursorPos(nPoint)
    
    If GetAsyncKeyState(VK_LBUTTON) And WindowFromPoint(nPoint.x, nPoint.Y) = hwnd Then Mouse_isUserClick = True

End Function
Public Function Mouse_isCursorOverControl(Control As Object, _
                                          Optional ErrorNumber As Long) As Boolean
    Dim P1 As POINTAPI, P2 As POINTAPI, Cur As POINTAPI
    Dim hwnd As Long, ERROR As Long
    
    On Local Error Resume Next
    
    ErrorNumber = 0
    hwnd = Control.hwnd
    ERROR = Err.Number
    
    Err.Clear
    
    On Local Error GoTo Quit

    If ERROR <> 0 Then
        With Control.Parent
            P1.x = .ScaleX(Control.Left, .ScaleMode, vbPixels)
            P1.Y = .ScaleY(Control.Top, .ScaleMode, vbPixels)
        
            Call ClientToScreen(.hwnd, P1)
    
            P2.x = .ScaleX(Control.Left + Control.Width, .ScaleMode, vbPixels)
            P2.Y = .ScaleY(Control.Top + Control.Height, .ScaleMode, vbPixels)
    
            Call ClientToScreen(.hwnd, P2)
        End With
    
        Call GetCursorPos(Cur)
    
        If (Cur.x >= P1.x And Cur.x <= P2.x) And (Cur.Y >= P1.Y And Cur.Y <= P2.Y) Then
            Mouse_isCursorOverControl = True
        End If
    Else
        Mouse_isCursorOverControl = (DLL.HARDWARE.Mouse_hWndUnderCursor = hwnd)
    End If
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call basPModule.ERROR(HARDWARE, "Mouse_isCursorOverControl", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Mouse_BlockUserInput(Optional BlockUserInput As Boolean = False) As Boolean
    Dim fBlock As Long, Result As Long
    
    fBlock = IIf(BlockUserInput, 1, 0)
    Result = BlockInput(fBlock)
    
    Mouse_BlockUserInput = (Result <> 0)
    
End Function
Public Function Mouse_ButtonCount() As Long

    Const SM_CMOUSEBUTTONS = 43

    Mouse_ButtonCount = GetSystemMetrics(SM_CMOUSEBUTTONS)

End Function
Public Function Mouse_Center(ByVal hwnd As Long, Optional ctrl As Object, _
                             Optional ErrorNumber As Long) As Boolean
    Dim P As POINTAPI
    Dim R As RECT
  
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If hwnd = 0 Then
        Call GetWindowRect(ctrl.hwnd, R)
    Else
        Call GetWindowRect(hwnd, R)
    End If
    
    P.x = R.Left + (R.Right - R.Left) / 2
    P.Y = R.Top + (R.Bottom - R.Top) / 2
    
    Call SetCursorPos(P.x, P.Y)
    
    Mouse_Center = True
     
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(HARDWARE, "Mouse_Center", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Mouse_ClipCursor(hwnd As Long, Optional UnClip As Boolean = False) As Boolean
    Dim R As RECT
   
    On Local Error GoTo Quit
   
    If UnClip Then
        Mouse_ClipCursor = Clip_Cursor(ByVal vbNullString)
    Else
        Call GetWindowRect(hwnd, R)
        Mouse_ClipCursor = Clip_Cursor(R)
    End If
       
Quit:
    If Err.Number <> 0 Then Call ERROR(HARDWARE, "Mouse_ClipCursor", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Mouse_isMoving() As Boolean
    Dim P1 As Position, P2 As Position
    
    Static P3 As Position
    
    If P3.x = 0 And P3.Y = 0 Then
        P1 = Mouse_GetPos()
    Else
        P1.x = P3.x
        P1.Y = P3.Y
    End If
    
    P2 = Mouse_GetPos()
        
    Mouse_isMoving = ((P1.x <> P2.x) Or (P1.Y <> P2.Y))
    
    P3.x = P2.x
    P3.Y = P2.Y
    
End Function
Public Sub Printer_ShowPageSetup(ByVal hwnd As Long)
    Dim m_PSD As PAGESETUPDLG
    
    On Local Error GoTo Quit
    
    With m_PSD
        .lStructSize = Len(m_PSD)
        .hWndOwner = hwnd
        .hInstance = App.hInstance
        .Flags = 0
    End With
    
    Call PAGESETUPDLG(m_PSD)
    
Quit:
    If Err.Number <> 0 Then Call ERROR(HARDWARE, "Printer_ShowPageSetup", Err.Number, Err.Description)

    Err.Clear
    
End Sub
Public Sub Printer_ShowPrinterDialog(ByVal hwnd As Long)
    Dim CM As COMMONDIALOGINFO
    
    CM.hwnd = hwnd
    CM.Flags = cdSHOWPRINTER
    
    Call DLL.CRTL.CommonDialog(CM)

End Sub
Public Function Soundcard_Installed() As Boolean
    
    Soundcard_Installed = ((waveOutGetNumDevs + midiOutGetNumDevs) > 0)

End Function
Public Function PCspeaker(Info As SPEAKERINFO) As Boolean
    Dim Value As String

    Const Path = "Control Panel\Sound"
    Const Key = "ExtendedSounds"

    Select Case Info
        Case spDISABLE
            PCspeaker = DLL.REGISTRY.ValueSet(HKEY_CURRENT_USER_, Path, Key, "No")
        Case spENABLE
            PCspeaker = DLL.REGISTRY.ValueSet(HKEY_CURRENT_USER_, Path, Key, "Yes")
        Case spISENABLED
            Value = DLL.REGISTRY.ValueGet(HKEY_CURRENT_USER_, Path, Key)
            Value = LCase$(Value)
    
            If Value = "ja" Or Value = "yes" Or Value = "true" Or Val(Value) > 0 Then
                PCspeaker = True
            End If
    End Select
    
End Function
Public Sub Monitor_StandBy(Command As MonitorCommand)

    Const ES_CONTINUOUS As Long = &H80000000
    Const ES_DISPLAY_REQUIRED As Long = &H2&

    Select Case Command
        Case mcDeactivate
            Call SetThreadExecutionState(ES_CONTINUOUS Or ES_DISPLAY_REQUIRED)
        Case mcActivate
            Call SetThreadExecutionState(ES_CONTINUOUS)
        Case Else
            '
    End Select
    
End Sub
Public Function Mainboard_GetInfo(Optional ErrorNumber As Long) As MainboardInfo
    Dim WMIClass As Object, Item As Object
    Dim MI As MainboardInfo
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Set WMIClass = GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf("Win32_BaseBoard")
    
    For Each Item In WMIClass
        MI.Caption = Item.Caption
        MI.Manufacturer = Item.Manufacturer
        MI.Product = Item.Product
        MI.Version = Item.Version
    Next Item
        
    Mainboard_GetInfo = MI
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(HARDWARE, "Get_MainboardInfo", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function VideoAdapter_GetInfo(Optional ErrorNumber As Long) As VideoAdapterInfo
    Dim WMIClass As Object, Item As Object
    Dim VI As VideoAdapterInfo
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Set WMIClass = GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf("Win32_VideoController")

    For Each Item In WMIClass
        VI.AdapterCompatibility = Item.AdapterCompatibility
        VI.AdapterRAM = VideoAdapter_Bytes2String(Item.AdapterRAM)
        VI.Caption = Item.Caption
        VI.DeviceID = Item.DeviceID
        VI.DRIVERVERSION = Item.DRIVERVERSION
        VI.InfFilename = Item.InfFilename
        VI.InfSection = Item.InfSection
        VI.InstalledDisplayDrivers = Item.InstalledDisplayDrivers
        VI.PNPDeviceID = Item.PNPDeviceID
        VI.Status = Item.Status
        VI.VideoProcessor = Item.VideoProcessor
        VI.VideoMemoryType = Get_VideoMemoryType(Item.VideoMemoryType)
        VI.Availability = Get_Availability(Item.Availability)
        VI.VideoArchitecture = Get_VideoArchitecture(Item.VideoArchitecture)
    Next Item

    VideoAdapter_GetInfo = VI
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(HARDWARE, "VideoAdapter_GetInfo", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function Printer_GetInfo() As PRINTEREXINFO
    Dim PI As PRINTEREXINFO
    Dim x As Long, pDc As Long
    
    Const DT_PLOTTER As Long = &H0&
    Const DT_RASDISPLAY As Long = &H1&
    Const DT_RASPRINTER As Long = &H2&
    Const DT_RASCAMERA As Long = &H3&
    Const DT_CHARSTREAM As Long = &H4&
    Const DT_METAFILE As Long = &H5&
    Const DT_DISPFILE As Long = &H6&

    pDc = Printer.hDC

    With PI
        .Name = Printer.DeviceName
        
        x = GetDeviceCaps(pDc, 2)
    
        Select Case x
            Case DT_PLOTTER:    .TECHNOLOGY = "TECHNOLOGY=PLOTTER"
            Case DT_RASDISPLAY: .TECHNOLOGY = "TECHNOLOGY=RASDISPLAY"
            Case DT_RASPRINTER: .TECHNOLOGY = "TECHNOLOGY=RASPRINTER"
            Case DT_RASCAMERA:  .TECHNOLOGY = "TECHNOLOGY=RASCAMERA"
            Case DT_CHARSTREAM: .TECHNOLOGY = "TECHNOLOGY=CHARSTREAM"
            Case DT_METAFILE:   .TECHNOLOGY = "TECHNOLOGY=METAFILE"
            Case DT_DISPFILE:   .TECHNOLOGY = "TECHNOLOGY=DISPFILE"
        End Select
    
        .DRIVERVERSION = GetDeviceCaps(pDc, 0)
        
        .Width_in_mm = GetDeviceCaps(pDc, 4)
        .Height_in_mm = GetDeviceCaps(pDc, 6)

        .Width_in_Pixel = GetDeviceCaps(pDc, 8)
        .Height_in_Pixel = GetDeviceCaps(pDc, 10)
    
        .DPI_in_X = GetDeviceCaps(pDc, 88)
        .DPI_in_Y = GetDeviceCaps(pDc, 90)
    
        .Brushes = GetDeviceCaps(pDc, 16)
        .Pens = GetDeviceCaps(pDc, 18)
        .Colors = GetDeviceCaps(pDc, 24)
    End With

    Printer_GetInfo = PI

End Function
Private Function subGetSmartID(ByRef smartStrVal As String, _
                               ByRef nID As Integer, nItem As Integer) As String
    Dim idx1 As Integer
    Dim strPart1() As String
    
    If Len(Trim$(smartStrVal)) = 0 Then Exit Function
    
    strPart1 = Split(smartStrVal, ",")
    
    For idx1 = 2 To UBound(strPart1) Step 12
        If CInt(strPart1(idx1)) = nID Then
            subGetSmartID = strPart1(idx1 + nItem)
            Exit Function
        End If
    Next idx1

End Function
Public Function HD_GetTemperature(ByVal DriveIndex As Long, _
                                  Optional ErrorNumber As Long) As String
    Dim objWMI As Object, objItem As Object, objInsts As Object
    Dim strTemp As String, strReturn As String
    Dim idx As Integer
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Set objWMI = GetObject("winmgmts:\\.\root\WMI")
    Set objInsts = objWMI.InstancesOf("MSStorageDriver_ATAPISmartData", 48)
          
    For Each objItem In objInsts
        If idx = DriveIndex Then
            strTemp = Join(objItem.VendorSpecific, ", ")
            strReturn = subGetSmartID(strTemp, 194, 5)
            
            Exit For
        End If
              
        idx = idx + 1
    Next
    
    HD_GetTemperature = Format$(strReturn, "##0.0")

Quit:
    If Err.Number <> 0 Then
        ErrorNumber = Err.Number
        
        Call ERROR(HARDWARE, "HD_GetTemperature", Err.Number, Err.Description)
    End If
    
    Set objItem = Nothing
    Set objWMI = Nothing

    Err.Clear

End Function
