VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Registry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum RegRoot
    HKEY_CLASSES_ROOT_ = HKEY_CLASSES_ROOT
    HKEY_CURRENT_USER_ = HKEY_CURRENT_USER
    HKEY_LOCAL_MACHINE_ = HKEY_LOCAL_MACHINE
    HKEY_USERS_ = HKEY_USERS
    HKEY_PERFORMANCE_DATA_ = HKEY_PERFORMANCE_DATA
    HKEY_CURRENT_CONFIG_ = HKEY_CURRENT_CONFIG
    HKEY_DYN_DATA_ = HKEY_DYN_DATA
End Enum

Public Type REGVALUE
    Item  As String
    Value As Variant
End Type

Public Type REGKEY
    Key As String
End Type

Public Function KeyExist(ByVal Root As RegRoot, ByVal Key As String) As Boolean
    Dim hKey As Long
    
    If RegOpenKeyEx(Root, Key, 0, KEY_READ, hKey) = 0 Then Call RegCloseKey(hKey): _
                                                           KeyExist = True

End Function
Public Function KeyCreate(ByVal Root As RegRoot, _
                          ByVal NewKey As String, Optional KeyValue As Variant) As Boolean
    Dim hKey As Long
    
    On Local Error Resume Next
    
    If RegCreateKey(Root, NewKey, hKey) = ERROR_SUCCESS Then
        If Not IsMissing(KeyValue) Then
            If KeyValue = "" Then KeyCreate = True
        End If
            
        If Not KeyCreate Then
            If RegSetValue(hKey, vbNullString, REG_SZ, KeyValue, 0) = ERROR_SUCCESS Then KeyCreate = True
        End If
    End If
    
    Call RegCloseKey(hKey)

    Err.Clear

End Function
Public Function KeyDelete(ByVal Root As RegRoot, ByVal Key As String) As Boolean
    KeyDelete = (RegDeleteKey(Root, Key) = ERROR_SUCCESS)
End Function
Public Function FieldDelete(ByVal Root As RegRoot, _
                            ByVal Key As String, ByVal Field As String) As Boolean
    Dim hKey As Long
    
    If RegOpenKeyEx(Root, Key, 0, KEY_ALL_ACCESS, hKey) = ERROR_SUCCESS Then
        If RegDeleteValue(hKey, Field) = ERROR_SUCCESS Then
            FieldDelete = True
            Call RegCloseKey(hKey)
        End If
    End If
    
End Function
Public Function ValueSet(ByVal Root As RegRoot, _
                         ByVal Key As String, ByVal Field As String, ByVal Value As Variant) As Boolean
    Dim Result As Long, hKey As Long, L As Long, P As Long
    Dim S As String
    Dim binData() As Byte
    Dim vt As VbVarType
    
    On Local Error GoTo Quit
    
    Call RegCreateKey(Root, Key, hKey)
        
    If RegOpenKeyEx(Root, Key, 0, KEY_ALL_ACCESS, hKey) = ERROR_SUCCESS Then
        vt = VBA.varType(Value)
        
        Select Case vt
            Case vbInteger, vbLong
                L = CLng(Value)
                Result = RegSetValueEx(hKey, Field, 0, REG_DWORD, L, 4)
            Case vbString, vbBoolean
                S = CStr(Value)
                Result = RegSetValueEx_Str(hKey, Field, 0, REG_SZ, S, Len(S) + 1)
            Case vbArray, vbByte
                ReDim binData(LBound(Value) To UBound(Value))
        
                For P = LBound(Value) To UBound(Value)
                    binData(P) = Value(P)
                Next P
        
                Result = RegSetValueByte(hKey, Field, 0&, REG_BINARY, binData(0), UBound(binData()) + 1)
        End Select
        
        If Result = ERROR_SUCCESS Then ValueSet = True
    End If
    
Quit:
    Call RegCloseKey(hKey)

    Err.Clear
    
End Function
Public Function ValueGet(ByVal Root As RegRoot, _
                         ByVal Key As String, _
                         ByVal Field As String, Optional ReturnedData As String) As Variant
    Dim Result As Long, hKey As Long, dwType As Long
    Dim Lng As Long, L As Long, P As Long
    Dim Buffer As String
    Dim Byt() As Byte
  
    If RegOpenKeyEx(Root, Key, 0, KEY_READ, hKey) = ERROR_SUCCESS Then
        If RegQueryValueEx(hKey, Field, 0&, dwType, ByVal 0&, L) = ERROR_SUCCESS Then
            Select Case dwType
                Case REG_SZ, REG_EXPAND_SZ
                    Buffer = Space$(L + 1)
                    Result = RegQueryValueEx(hKey, Field, 0&, dwType, ByVal Buffer, L)
                    If Result = ERROR_SUCCESS Then ValueGet = Left$(Buffer, Len(Buffer) - 2)
                Case REG_DWORD
                    Result = RegQueryValueEx(hKey, Field, 0&, dwType, Lng, L)
                    If Result = ERROR_SUCCESS Then ValueGet = Lng
                Case REG_BINARY
                    Result = RegQueryValueEx(hKey, Field, 0&, dwType, ByVal 0&, L)
                    
                    If Result = ERROR_SUCCESS Then
                        If dwType = REG_BINARY Then
                            ReDim Byt(L - 1) As Byte
                                
                            Result = RegQueryValueEx(hKey, Field, 0&, dwType, Byt(0), L)
                            
                            If Result = ERROR_SUCCESS Then
                                ValueGet = Byt
                                
                                For P = 0 To UBound(Byt)
                                    ReturnedData = ReturnedData & Chr$(Byt(P))
                                Next P
                            End If
                        End If
                    End If
            End Select
        End If
    End If
    
    Call RegCloseKey(hKey)
    
End Function
Public Function EnumKey(ByVal Root As RegRoot, ByVal Key As String) As REGKEY()
    Dim hKey As Long, Cnt As Long, Ret As Long
    Dim sName As String
    Dim RV() As REGKEY
    
    Ret = BUFFER_SIZE
    Cnt = 0
    
    If RegOpenKey(Root, Key, hKey) <> 0 Then Exit Function
    
    sName = Space(BUFFER_SIZE)
                
    While RegEnumKeyEx(hKey, Cnt, sName, Ret, ByVal 0&, vbNullString, ByVal 0&, ByVal 0&) <> ERROR_NO_MORE_ITEMS
        ReDim Preserve RV(Cnt)
        RV(Cnt).Key = Left$(sName, Ret)
        
        Cnt = Cnt + 1

        sName = Space(BUFFER_SIZE)
        Ret = BUFFER_SIZE
    Wend
    
    Call RegCloseKey(hKey)

    EnumKey = RV
    
End Function
Public Function EnumValue(ByVal Root As RegRoot, ByVal Key As String) As REGVALUE()
    Dim hKey As Long, Cnt As Long, Ret As Long, RetData As Long
    Dim sName As String, sData As String
    Dim RG() As REGVALUE
    
    Ret = BUFFER_SIZE
    Cnt = 0
    
    If RegOpenKey(Root, Key, hKey) Then Exit Function
    
    sName = Space(BUFFER_SIZE)
    sData = Space(BUFFER_SIZE)
        
    Ret = BUFFER_SIZE
    RetData = BUFFER_SIZE
    
    While RegEnumValueA(hKey, Cnt, sName, Ret, 0, ByVal 0&, ByVal sData, RetData) <> ERROR_NO_MORE_ITEMS
        If RetData > 0 Then
            ReDim Preserve RG(Cnt)
            
            RG(Cnt).Item = Left$(sName, Ret)
            RG(Cnt).Value = Left$(sData, RetData - 1): _
            
            Cnt = Cnt + 1
        End If
            
        sName = Space(BUFFER_SIZE)
        sData = Space(BUFFER_SIZE)
            
        Ret = BUFFER_SIZE
        RetData = BUFFER_SIZE
    Wend
    
    Call RegCloseKey(hKey)
    
    EnumValue = RG

End Function
Public Function RegEnum(ByVal Root As RegRoot, ByVal Key As String, REGKEYLIST() As REGKEY) As REGVALUE()
    Dim RK() As REGKEY
    Dim RV() As REGVALUE
        
    RK = EnumKey(Root, Key)
    RV = EnumValue(Root, Key)
    
    REGKEYLIST = RK
    
End Function
Private Function GetRootWord(Root As RegRoot) As String
    Dim R$
    
    Select Case Root
        Case HKEY_CLASSES_ROOT_:     R$ = "HKEY_CLASSES_ROOT"
        Case HKEY_CURRENT_USER_:     R$ = "HKEY_CURRENT_USER"
        Case HKEY_LOCAL_MACHINE_:    R$ = "HKEY_LOCAL_MACHINE"
        Case HKEY_USERS_:            R$ = "HKEY_USERS"
        Case HKEY_PERFORMANCE_DATA_: R$ = "HKEY_PERFORMANCE_DATA"
        Case HKEY_CURRENT_CONFIG_:   R$ = "HKEY_CURRENT_CONFIG"
        Case HKEY_DYN_DATA_:         R$ = "HKEY_DYN_DATA"
    End Select

    GetRootWord = R$

End Function
Public Function ExportKey(Root As RegRoot, _
                          ByVal Key As String, _
                          ByVal File As String) As Boolean
        
    If Not KeyExist(Root, Key) Then Exit Function
    
    Call DLL.File.fKill(File)

    If DLL.File.Create_File(File) <> 0 Then Exit Function
    
    Call SHELL("Regedit /e /s " & File & " " & GetRootWord(Root) & "\" & Key, vbHide)

    If FileLen(File) > 0 Then ExportKey = True
    
End Function
