VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Office"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum OfficeCommand
    oaGETPATH = 1
    oaISINSTALLED = 2
    oaOPENDOCUMENT = 3
    oaRUN = 4
End Enum

Public Enum OfficeApplication
    opMSACCESS = 0
    opMSWORD = 1
    opMSEXCEL = 2
    opMSOUTLOOK = 3
    opMSPOWERPOINT = 4
    opMSFRONTPAGE = 5
End Enum
Public Function Word_PrintDocument(ByVal DocPath As String) As Long
    Dim Word As Object
    
    On Local Error GoTo Quit
    
    If Not DLL.File.Exist(DocPath) Then GoTo Quit
    
    Set Word = CreateObject("Word.Application")
    
    With Word
        .Visible = False
        .Documents.Open DocPath, , True
        .PrintOut
    End With
    
Quit:
    If Err.Number <> 0 Then
        Word_PrintDocument = Err.Number

        Call ERROR(Office, "Word_PrintDocument", Err.Number, Err.Description)
    End If
    
    On Local Error Resume Next
    
    Word.Application.Quit
    Set Word = Nothing
    
    Err.Clear
    
End Function
Public Function OfficeApp(App As OfficeApplication, _
                          Command As OfficeCommand, _
                          Optional DocumentPath As String) As String
    Dim Key As String, Field As String, Path As String
    
    Select Case Command
        Case oaGETPATH
            Select Case App
                Case opMSACCESS:     Field = "MSACCESS.EXE"
                Case opMSEXCEL:      Field = "Excel.exe"
                Case opMSOUTLOOK:    Field = "OUTLOOK.EXE"
                Case opMSPOWERPOINT: Field = "PowerPnt.exe"
                Case opMSFRONTPAGE:  Field = "frontpg.exe"
                Case opMSWORD:       Field = "Winword.exe"
                
                Case Else:           Exit Function
            End Select
    
            Key = "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\" & Field
            Path = DLL.REGISTRY.ValueGet(HKEY_LOCAL_MACHINE_, Key, "Path")
            If Path <> "" Then Path = GetDir(Path) & Field
    
            OfficeApp = Path
        Case oaISINSTALLED
            Path = OfficeApp(App, oaGETPATH)
                        
            OfficeApp = IIf(Path <> "", "True", "False")
        Case oaOPENDOCUMENT
            Path = OfficeApp(App, oaGETPATH)
            DocumentPath = DLL.File.Get_ShortPath(DocumentPath)
                        
            On Local Error Resume Next
            SHELL Path & " " & DocumentPath, vbMaximizedFocus
             
            OfficeApp = IIf(Err.Number = 0, "True", "False")
        Case oaRUN
            Path = OfficeApp(App, oaGETPATH)
                                    
            On Local Error Resume Next
            SHELL Path, vbMaximizedFocus
             
            OfficeApp = IIf(Err.Number = 0, "True", "False")
        Case Else: Exit Function
    End Select
    
End Function
